/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef COMPGEOMETRYH
#define COMPGEOMETRYH

#include "array.h"

#include "Point3.h"
#include "Vector3.h"
#include "Plane.h"


#define EPSILON_SQUARED 0.000000000000001



double areaOfPoly(const array<Point3>& poly);
bool isPolyClockwise(const array<Point3>& poly);
void flipPoly(array<Point3>& poly);
double areaOfTriangle(const Point3& a, const Point3& b, const Point3& c);
bool isTriangleClockwise(const Point3& a, const Point3& b, const Point3& c);
bool triangleContainsPoint(const Point3& a, const Point3& b,
									const Point3& c, const Point3& p);
void generateEdgePlanes(const array<Point3>& poly, array<Plane>& edgePlanes);
bool isPolySelfIntersecting(const array<Point3>& poly);
bool polyHasDegenerateEdges(const array<Point3>& poly);
void flattenPoly(array<Point3>& poly);



#endif
