/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPCOPY_CPP
#define __TOOLGROUPCOPY_CPP

#include "ToolGroupCopy.h"

#include <gtk/gtklabel.h>



ToolGroupCopy::ToolGroupCopy(ProcessToolManager *toolManager,
									  JournalEditor *journEditor, CadView *view,
									  ObjectCollection *collection)
		: MToolGroup(toolManager)
{
	titleLabel = gtk_label_new("Copy");
	gtk_widget_ref(titleLabel);
	gtk_widget_show(titleLabel);

	journalEditor = journEditor;
	objectCollection = collection;

	copyButton = addToolButton( "Copy", GTK_SIGNAL_FUNC(copyClicked) );

	toolCopy = new ToolCopy( view );

	toolMan->addTool( toolCopy->getProcessType(), toolCopy );
}

ToolGroupCopy::~ToolGroupCopy()
{
	gtk_widget_unref(titleLabel);
	
	toolMan->eraseTool( toolCopy->getProcessType() );
	delete toolCopy;
}



void ToolGroupCopy::addToLayout(GridLayout *layout)
{
	MToolGroup::addToLayout(layout);

	layout->addAsLine(titleLabel);
	layout->add(copyButton);
}




void ToolGroupCopy::copyClicked(GtkWidget *widget, ToolGroupCopy *klass)
{
	ProcCopy *p = new ProcCopy();
	klass->journalEditor->addProcess(p);
	delete p;
}



#endif
