/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPCOPY_H
#define __TOOLGROUPCOPY_H

#include <gtk/gtkwidget.h>

#include "MToolGroup.h"

#include "JournalEditor.h"

#include "CadView.h"
#include "Toolbox.h"
#include "ToolCopy.h"
#include "ObjPainterManager.h"
#include "ObjectCollection.h"



class ToolGroupCopy : public MToolGroup
{
private:
	JournalEditor *journalEditor;
	ObjectCollection *objectCollection;

	GtkWidget *titleLabel;
	GtkWidget *copyButton;

	ToolCopy *toolCopy;

	

public:
	ToolGroupCopy(ProcessToolManager *toolManager,
					  JournalEditor *journEditor, CadView *view,
					  ObjectCollection *collection);
	virtual ~ToolGroupCopy();


	virtual void addToLayout(GridLayout *layout);


private:
	static void copyClicked(GtkWidget *widget, ToolGroupCopy *klass);
};



#endif
