/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPCREATEMESH_H
#define __TOOLGROUPCREATEMESH_H

#include <gtk/gtkwidget.h>

#include "MToolGroup.h"

#include "ToolCreateCube.h"
#include "ToolCreatePatch.h"
#include "ToolCreateTorus.h"
#include "JournalEditor.h"

#include "CadView.h"
#include "Toolbox.h"
#include "ObjPainterManager.h"



class ToolGroupCreateMesh : public MToolGroup
{
private:
	JournalEditor *journalEditor;

	GtkWidget *titleLabel;
	GtkWidget *cubeButton, *patchButton, *torusButton;

	ToolCreateCube *toolCube;
	ToolCreatePatch *toolPatch;
	ToolCreateTorus *toolTorus;
	

public:
	ToolGroupCreateMesh( ProcessToolManager *toolManager,
								JournalEditor *journEditor, CadView *view );
	virtual ~ToolGroupCreateMesh();


	virtual void addToLayout(GridLayout *layout);


private:
	static void cubeClicked(GtkWidget *widget, ToolGroupCreateMesh *klass);
	static void patchClicked(GtkWidget *widget, ToolGroupCreateMesh *klass);
	static void torusClicked(GtkWidget *widget, ToolGroupCreateMesh *klass);
};



#endif
