/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPCREATEPOLYLINE_CPP
#define __TOOLGROUPCREATEPOLYLINE_CPP

#include "ToolGroupCreatePolyline.h"

#include <gtk/gtklabel.h>



ToolGroupCreatePolyline::ToolGroupCreatePolyline(
				ProcessToolManager *toolManager,
				JournalEditor *journEditor, CadView *view )
		: MToolGroup(toolManager)
{
	titleLabel = gtk_label_new("Create Polyline");
	gtk_widget_ref(titleLabel);
	gtk_widget_show(titleLabel);

	journalEditor = journEditor;

	drawButton = addToolButton( "Draw", GTK_SIGNAL_FUNC(drawClicked) );
	polygonButton = addToolButton( "Polygon", GTK_SIGNAL_FUNC(polygonClicked) );

	toolDraw = new ToolPolyDraw(view);
	toolPolygon = new ToolPolyPolygon(view);

	toolMan->addTool(toolDraw->getProcessType(), toolDraw);
	toolMan->addTool(toolPolygon->getProcessType(), toolPolygon);
}

ToolGroupCreatePolyline::~ToolGroupCreatePolyline()
{
	gtk_widget_unref(titleLabel);
	
	toolMan->eraseTool(toolDraw->getProcessType());
	toolMan->eraseTool(toolPolygon->getProcessType());
	delete toolDraw;
	delete toolPolygon;
}



void ToolGroupCreatePolyline::addToLayout(GridLayout *layout)
{
	MToolGroup::addToLayout(layout);

	layout->addAsLine(titleLabel);
	layout->add(drawButton);
	layout->add(polygonButton);
}




void ToolGroupCreatePolyline::drawClicked(GtkWidget *widget,
														ToolGroupCreatePolyline *klass)
{
	ProcPolyDraw *p = new ProcPolyDraw();
	klass->journalEditor->addProcess(p);
	delete p;
}

void ToolGroupCreatePolyline::polygonClicked(GtkWidget *widget,
															ToolGroupCreatePolyline *klass)
{
	ProcPolyPolygon *p = new ProcPolyPolygon();
	klass->journalEditor->addProcess(p);
	delete p;
}



#endif
