/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPCREATEPOLYLINE_H
#define __TOOLGROUPCREATEPOLYLINE_H

#include <gtk/gtkwidget.h>

#include "MToolGroup.h"

#include "ToolPolyDraw.h"
#include "ToolPolyPolygon.h"
#include "JournalEditor.h"

#include "CadView.h"
#include "Toolbox.h"
#include "ObjPainterManager.h"



class ToolGroupCreatePolyline : public MToolGroup
{
private:
	JournalEditor *journalEditor;

	GtkWidget *titleLabel;
	GtkWidget *drawButton, *polygonButton;

	ToolPolyDraw *toolDraw;
	ToolPolyPolygon *toolPolygon;
	

public:
	ToolGroupCreatePolyline( ProcessToolManager *toolManager,
									 JournalEditor *journEditor, CadView *view );
	virtual ~ToolGroupCreatePolyline();


	virtual void addToLayout(GridLayout *layout);


private:
	static void drawClicked(GtkWidget *widget, ToolGroupCreatePolyline *klass);
	static void polygonClicked(GtkWidget *widget, ToolGroupCreatePolyline *klass);
};



#endif
