/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		25/Jun/2000
*/
#ifndef __TOOLKITCREATEOBJECT_CPP
#define __TOOLKITCREATEOBJECT_CPP

#include "ToolkitCreateObject.h"



ToolkitCreateObject::ToolkitCreateObject(Toolbox *tbx, CadView *view,
													  JournalEditor *journalEditor,
													  ProcessToolManager *toolManager,
													  ObjectCollection *collection)
													  : MToolkit(tbx)
{
	createObjectToolset =
		new ToolsetCreateObject( tbox, view, journalEditor, toolManager,
										 collection );
}

ToolkitCreateObject::~ToolkitCreateObject()
{
	delete createObjectToolset;
}


void ToolkitCreateObject::install()
{
	MToolkit::install();
	tbox->addToolset( createObjectToolset->getWidget(), "Create" );
}

void ToolkitCreateObject::uninstall()
{
	MToolkit::uninstall();
	tbox->removeToolset( createObjectToolset->getWidget() );
}


#endif
