/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLSETCREATEOBJECT_CPP
#define __TOOLSETCREATEOBJECT_CPP

#include <gtk/gtklabel.h>
#include <gtk/gtkbutton.h>
#include <gtk/gtksignal.h>

#include "ToolsetCreateObject.h"




ToolsetCreateObject::ToolsetCreateObject(Toolbox *tbx, CadView *vw,
													  JournalEditor *journEditor,
													  ProcessToolManager *toolManager,
													  ObjectCollection *collection)
													  : Toolset(tbx)
{
	polyGroup = new ToolGroupCreatePolyline( toolManager, journEditor, vw );
	meshGroup = new ToolGroupCreateMesh( toolManager, journEditor, vw );
	copyGroup = new ToolGroupCopy( toolManager, journEditor, vw, collection );

	polyGroup->addToLayout(&layout);
	layout.lineSpace(1);
	meshGroup->addToLayout(&layout);
	layout.lineSpace(1);
	copyGroup->addToLayout(&layout);
}

ToolsetCreateObject::~ToolsetCreateObject()
{
	delete polyGroup;
	delete meshGroup;
	delete copyGroup;
}


#endif
