/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __CEDGE_CPP
#define __CEDGE_CPP

#include "CEdge.h"


/*
*******************************************************************************
												CEdge
*******************************************************************************
*/

CEdge::CEdge(int a, int b)
{
	vts[0] = a < b ? a : b;
	vts[1] = a < b ? b : a;
}



bool CEdge::operator<(const CEdge& e) const
{
	if ( vts[0] < e.vts[0] )
	{
		return true;
	}
	else if ( vts[0] == e.vts[0] )
	{
		return vts[1] < e.vts[1];
	}
	else
	{
		return false;
	}
}



int CEdge::operator[](int i) const
{
	return vts[i];
}



#endif
