/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __CADEDITOR_CPP
#define __CADEDITOR_CPP

#include <gtk/gtkmarshal.h>

#include "CadEditor.h"



CadEditor::CadEditor(CadView *v, const string& wintitle,
							GtkSignalFunc closeCallbackFunc, gpointer closeCallbackData)
{
	win = new CadEditorWindow(v, wintitle);
	vw = v;
	rflag = false;
	closeFunc = closeCallbackFunc;
	closeData = closeCallbackData;
}

CadEditor::~CadEditor()
{
	delete win;
}

void CadEditor::run()
{
	win->go( GTK_SIGNAL_FUNC(winClosed), this );
	rflag = true;
}

bool CadEditor::isRunning() const
{
	return rflag;
}

void CadEditor::shutdown()
{
	rflag = false;
}


void CadEditor::winClosed(CadEditorWindow *w, CadEditor *klass)
{
	klass->shutdown();

	gtk_marshal_NONE__NONE( (GtkObject*)klass, klass->closeFunc, klass->closeData,
									(GtkArg*)NULL );
}



#endif
