/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		16/Apr/2000
*/
#ifndef __CADEDITOR_H
#define __CADEDITOR_H


#include "CadEditorWindow.h"
#include "CadView.h"



class CadEditor
{
protected:
	CadEditorWindow *win;
	CadView *vw;
	bool rflag;

	GtkSignalFunc closeFunc;
	gpointer closeData;


public:
	CadEditor(CadView *v, const string& wintitle,
				 GtkSignalFunc closeCallbackFunc, gpointer closeCallbackData);
	virtual ~CadEditor();
	
	virtual void run();

	bool isRunning() const;

protected:
	virtual void shutdown();

private:
	static void winClosed(CadEditorWindow *w, CadEditor *klass);
};


#endif

