/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		10/Jul/2000
*/
#ifndef __CADEDITORWINDOW_H
#define __CADEDITORWINDOW_H

#include <list>

#include <gtk/gtkwidget.h>
#include <gtk/gtksignal.h>


#include "CadView.h"
#include "Toolbox.h"
#include "Toolset.h"
#include "StatusBar.h"



class CadEditorWindow : public Toolbox
{
private:
	GtkWidget *win;			//window containing winvbox
	GtkWidget *winvbox;		//vbox containing workhbox and statusbar

	GtkWidget *workhbox;		//hbox containing toolbox and the CadView

	GtkWidget *toolbox;		//notebook

	StatusBar *statusBar;

	string wtitle;


	GtkSignalFunc closeFunc;
	gpointer closeData;
	

public:
	CadEditorWindow(CadView *vw, const string& wintitle);
	virtual ~CadEditorWindow();


	virtual void addToolset(GtkWidget *ts, const string& name,
									bool makeCurrent = false);
	virtual void removeToolset(GtkWidget *ts);
	virtual void setCurrentToolset(GtkWidget *ts);
	void addToolset(Toolset *toolset, const string& name,
						 bool makeCurrent = false);

	StatusBar* getStatusBar();

	void go(GtkSignalFunc closeCallbackFunc, gpointer closeCallbackData);
	void stop();



private:
	static void win_destroy(GtkWidget *widget, CadEditorWindow *klass);
};



#endif
