/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __STATUSBAR_CPP
#define __STATUSBAR_CPP

#include <gtk/gtkhbox.h>
#include <gtk/gtklabel.h>

#include "StatusBar.h"



StatusBar::StatusBar()
{
	label = gtk_label_new("Ready");
	gtk_widget_ref(label);
	gtk_widget_show(label);

	box = gtk_hbox_new(false, 0);
	gtk_widget_ref(box);


	add(label);
}

StatusBar::~StatusBar()
{
	gtk_widget_unref(label);
	gtk_widget_unref(box);
}




void StatusBar::add(GtkWidget *widget)
{	
	gtk_box_pack_start( GTK_BOX(box), widget, true, true, 5 );
}

void StatusBar::remove(GtkWidget *widget)
{
	gtk_container_remove( GTK_CONTAINER(box), widget );
}


void StatusBar::setLabelText(const string& text)
{
	gtk_label_set_text( GTK_LABEL(label), text.c_str() );
}


GtkWidget* StatusBar::getWidget()
{
	return box;
}


#endif
