/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by :					Geoffrey French
	application :		gSculpt
	last revision :	02/Jul/2000
	title :				CAD Face class
	puspose :			Store information on a face in a 3D model
*/
#ifndef __CFACE_H
#define __CFACE_H

#include <stdio.h>

#include <vector>

#include "Point3.h"


/*
*******************************************************************************
												CFace
*******************************************************************************
*/


class CFace
{
public:
	class Vertex
	{
	public:
		int vertexNum;
		Point3 texture;

		Vertex();
		Vertex(int n, const Point3& t);
	};
	
private:
	vector<Vertex> vts;
	int patchIndex;

public:
	CFace();
	CFace(Vertex a, Vertex b, Vertex c, int patch);
	CFace(int va, const Point3& ta,
			int vb, const Point3& tb,
			int vc, const Point3& tc, int patch);
	CFace(Vertex a, Vertex b, Vertex c, Vertex d, int patch);
	CFace(int va, const Point3& ta,
			int vb, const Point3& tb,
			int vc, const Point3& tc,
			int vd, const Point3& td, int patch);


	void read(FILE *f);
	void write(FILE *f) const;


	void addVertex(Vertex vtx);


	void copyFrom(const CFace *f);


	const Vertex& operator[](int i) const;
	int size() const;

	int getPatchIndex() const;
};



#endif
