/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __CFACECONTAINER_CPP
#define __CFACECONTAINER_CPP

#include "CFaceContainer.h"



/*
*******************************************************************************
											CFaceContainer
*******************************************************************************
*/


void CFaceContainer::read(FILE *f)
{
	clear();

	int numFaces;
	fread( &numFaces, sizeof(int), 1, f );

	for (int i = 0; i < numFaces; i++)
	{
		CFace face;

		face.read(f);
		push_back(face);
	}
}

void CFaceContainer::write(FILE *f) const
{
	int numFaces = size();
	fwrite( &numFaces, sizeof(int), 1, f );

	for (int i = 0; i < (int)size(); i++)
	{
		const CFace &face = get(i);

		face.write(f);
	}
}

CFace& CFaceContainer::get(int i)
{
	return (*this)[i];
}

const CFace& CFaceContainer::get(int i) const
{
	return (*this)[i];
}


void CFaceContainer::copyFrom(const CFaceContainer *c)
{
	resize( c->size() );

	for (int i = 0; i < (int)c->size(); i++)
	{
		get(i).copyFrom( &( c->get(i) ) );
	}
}



#endif
