/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __JOURNALTASKMONITOR_H
#define __JOURNALTASKMONITOR_H

#include <gtk/gtkwidget.h>
#include <gtk/gtksignal.h>

#include "StatusBar.h"

#include "JournalTaskProgress.h"



class JournalTaskMonitor
{
private:
	JournalTaskProgress *progress;
	StatusBar *statusBar;

	GtkWidget *progressBar;
	

	int countStart;


	guint startId, idleId, updateId;
	bool showingProgressFlag;


	GtkSignalFunc finFunc;
	gpointer finData;



public:
	JournalTaskMonitor(StatusBar *statBar);

	void start(JournalTaskProgress *p, GtkSignalFunc finishedFunction,
				  gpointer finishedData);
	

private:
	void startProgressBars();
	void finished();
	void updateProgress();

	static gint waitToStartFunction(JournalTaskMonitor *klass);
	static gint idleFunction(JournalTaskMonitor *klass);
	static gint updateProgressFunction(JournalTaskMonitor *klass);
};






#endif
