/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __JOURNALTASKPROGRESS_H
#define __JOURNALTASKPROGRESS_H


#include <string>

#include "MultiThreading.h"




class JournalTaskProgress
{
private:
	JournalTaskProgress *nestedTask;
	string subtaskDescription;
	int subtaskProgress, subtaskLength;
	int subtasksComplete, numSubtasks;
	bool completeFlag;
	GSCMutex *taskMutex;

public:
	JournalTaskProgress();
	~JournalTaskProgress();


	void lock();
	void unlock();


	void reset();

	void setNestedTask(JournalTaskProgress *task);
	JournalTaskProgress* getNestedTask();

	void setSubtaskDescription(const string& s);
	string getSubtaskDescription();

	void setSubtaskLength(int l);
	void setSubtaskProgress(int p);
	void setSubtasksComplete(int t);
	void setNumSubtasks(int n);
	void setComplete(bool c);
	int getSubtaskLength() const;
	int getSubtaskProgress() const;
	int getSubtasksComplete() const;
	int getNumSubtasks() const;
	bool isComplete() const;

	float getFraction() const;
};



#endif
