/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPLOFTPOLY_H
#define __TOOLGROUPLOFTPOLY_H

#include <gtk/gtkwidget.h>

#include "MToolGroup.h"

#include "ToolLoftPolyExtrude.h"
#include "ToolLoftPolySpin.h"
#include "JournalEditor.h"

#include "CadView.h"
#include "Toolbox.h"
#include "ObjPainterManager.h"



class ToolGroupLoftPoly : public MToolGroup
{
private:
	JournalEditor *journalEditor;

	GtkWidget *titleLabel;
	GtkWidget *extrudeButton, *spinButton;

	ToolLoftPolyExtrude *toolExtrude;
	ToolLoftPolySpin *toolSpin;
	

public:
	ToolGroupLoftPoly(ProcessToolManager *toolManager,
							JournalEditor *journEditor, CadView *view,
							ObjPainterManager *painterManager);
	virtual ~ToolGroupLoftPoly();


	virtual void addToLayout(GridLayout *layout);


private:
	static void extrudeClicked(GtkWidget *widget, ToolGroupLoftPoly *klass);
	static void spinClicked(GtkWidget *widget, ToolGroupLoftPoly *klass);
};



#endif
