/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLLOFTSPIN_H
#define __TOOLLOFTSPIN_H

#include <gtk/gtkwidget.h>
#include <gtk/gtkobject.h>

#include <string>


#include "JournalProcess.h"
#include "ProcessTool.h"
#include "NumericEntry.h"



class ProcLoftPolySpin : public JournalProcess
{
private:
	int segments;
	bool flattenFlag;
	
public:
	ProcLoftPolySpin();
	ProcLoftPolySpin(int spinSegs, bool flatten);
	virtual ~ProcLoftPolySpin();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual const ObjectType* getInputType() const;

	virtual JournalProcess* clone() const;

	int getSpinSegments() const;
	bool getFlatten() const;
	void setSpinSegments(int n);
	void setFlatten(bool flatten);
	
protected:
	virtual const ObjectType* _getOutputType(const ObjectType* inputType) const;
	virtual JournalObject* _process(JournalObject *o,
											  JournalTaskProgress *progress);
};




class ToolLoftPolySpin : public ProcessTool
{
private:
	GtkWidget *flattenCheck;
	
	GtkWidget *segmentsLabel;
	NumericEntry *segmentsEntry;
	
	GtkWidget *doneButton;

public:
	ToolLoftPolySpin(CadView *v);
	~ToolLoftPolySpin();


	virtual const ObjectType* getProcessType() const;


protected:
	virtual void initialise();


private:
	static void segmentsChanged(NumericEntry *widget, ToolLoftPolySpin *klass);
	static void flattenClicked(GtkWidget *widget, ToolLoftPolySpin *klass);
	static void doneClicked(GtkWidget *widget, ToolLoftPolySpin *klass);
};


#endif
