/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef CGRIDH
#define CGRIDH

#include <list>


#include "array.h"

#include "Vector3.h"
#include "Point3.h"
#include "Line3.h"
#include "DrawingArea.h"

#include "Grid.h"


/*
*******************************************************************************
													CGrid
*******************************************************************************
*/

class CGrid : public Grid
{
private:
	//colours of levels shown
	array<DAColour> colours;

public:
	CGrid();
	CGrid(const Ruler& rul, bool useSmallest, double multiplier);
	CGrid(const Ruler& rul, bool useSmallest, double multiplier,
			const array<DAColour>& cols);

	//get the color for a specific grid number
	DAColour& getGridColour(int gridNo);
};


#endif
