/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef GRIDH
#define GRIDH

#include "Point3.h"
#include "Line3.h"
#include "Ruler.h"




class Grid
{
private:
	Ruler r;
	bool usm;
	Point3 p1, p2;
	double mul;

public:
	Grid();
	Grid(const Ruler& rul, bool useSmallest, double multiplier);


	void setCorners(const Point3& p, const Point3& q);

	array<Line3> generateHLines(int level) const;
	array<Line3> generateVLines(int level) const;

	int nLevels() const;
	const Ruler& getRuler() const;
};



#endif
