/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef LOGMULTISCALECPP
#define LOGMULTISCALECPP

#include "LogMultiScale.h"



LogMultiScale::LogMultiScale() : LogScale()
{
	nLevs = 2;
}

LogMultiScale::LogMultiScale(double bs, const array<double> pwr, int nLevels)
									  : LogScale(bs, pwr)
{
	nLevs = nLevels;
}


array<LogScale::Level> LogMultiScale::generateLevels(double sz) const
{
	array<LogScale::Level> levels;

	LogScale::Level l = getSmaller(sz);

	for (int i = 0; i < nLevs; i++)
	{
		levels.push_back(l);
		--l;
	}

	return levels;
}


int LogMultiScale::nLevels() const
{
	return nLevs;
}





#endif
