/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef LOGSCALEH
#define LOGSCALEH

#include "array.h"

#include <math.h>




class LogScale
{
public:
	class Level
	{
	private:
		const LogScale *ls;
		int major, minor;

	public:
		Level();
		Level(const LogScale *l, int maj, int min);


		Level& operator++();
		Level operator++(int);
		Level& operator+=(int i);
		Level operator+(int i) const;
		Level& operator--();
		Level operator--(int);
		Level& operator-=(int i);
		Level operator-(int i) const;

		double getValue() const;
		double getPower() const;
	};

private:
	double base;
	array<double> powers;

public:
	LogScale();
	LogScale(double bs, const array<double> pwr);



	Level getSmaller(double v) const;
	Level getNearest(double v) const;
	Level getLarger(double v) const;

private:
	Level find(double pwr) const;	
	

	friend class LogScale::Level;
};




#endif
