/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef RULERCPP
#define RULERCPP

#include "Ruler.h"




Ruler::Ruler()
{
}

Ruler::Ruler(const LogMultiScale& s)
{
	sc = s;
}


void Ruler::setLength(double l)
{
	levels = sc.generateLevels(l);
}


array<double> Ruler::generateTicks(double lower, double upper, int level) const
{
	int l, u;
	array<double> result;

	l = (int)(lower / levels[level].getValue() );
	u = (int)(upper / levels[level].getValue() );

	for (int i = l; i <= u; i++)
	{
		result.push_back( (double)i * levels[level].getValue() );
	}

	return result;
}


int Ruler::nLevels() const
{
	return sc.nLevels();
}

const LogMultiScale& Ruler::getScale() const
{
	return sc;
}

const array<LogMultiScale::Level>& Ruler::getLevels() const
{
	return levels;
}



#endif
