/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef RULERH
#define RULERH

#include "LogMultiScale.h"

#include "array.h"



class Ruler
{
private:
	LogMultiScale sc;

	array<LogMultiScale::Level> levels;


public:
	Ruler();
	Ruler(const LogMultiScale& s);


	void setLength(double l);

	array<double> generateTicks(double lower, double upper, int level) const;

	int nLevels() const;
	const LogMultiScale& getScale() const;
	const array<LogMultiScale::Level>& getLevels() const;
};


#endif
