/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef AXES3H
#define AXES3H

#include "Point3.h"
#include "Vector3.h"
#include "Matrix4.h"



class Axes3
{
public:
	Vector3 i, j, k;


public:
	Axes3();
	Axes3(const Vector3& ai, const Vector3& aj, const Vector3& ak);
	Axes3(Axis axesIdentifier);


	Axes3 operator+(const Axes3& a) const;
	Axes3& operator+=(const Axes3& a);
	Axes3 operator*(double t) const;
	Axes3& operator*=(double t);

	Axes3 operator~() const;


	Matrix4 matrixTransformation() const;
	Matrix4 toAxesTransformation(const Axes3& a) const;
};



Axes3 operator*(const Axes3& a, const Matrix4& m);



#endif
