/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef LINE3H
#define LINE3H

#include "Point3.h"
#include "Vector3.h"
#include "Plane.h"
#include "Matrix4.h"



class Line3
{
public:
	Point3 s, e;


	Line3();
	Line3(const Point3& start, const Point3& end);
	Line3(const Point3& start, const Vector3& direction);


	Vector3 direction() const;
	bool intersect(const Plane& p, Point3& intersection) const;
	
	bool clip(const Plane& p);
};


Line3 operator*(const Line3& l, const Matrix4& m);



#endif
