/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef PLANEH
#define PLANEH

#include "Vector3.h"
#include "Point3.h"



class Plane
{
public:
	Vector3 n;
	double d;


	Plane();
	Plane(const Vector3& normal, double distance);
	Plane(const Vector3& normal, const Point3& a);
	Plane(const Point3& a, const Vector3& u, const Vector3& v);
	Plane(const Point3& a, const Point3& b, const Point3& c);

	bool operator!=(const Plane& cmp) const;


	Plane operator-() const;


	double dist(const Point3& p) const;
	Point3 point() const;


	bool intersect(const Point3& st, const Vector3& dir, double& t) const;
	bool intersect(const Point3& st, const Point3& en, double& t) const;
};


bool operator==(const Plane& pl, const Point3& pt);
bool operator==(const Point3& pt, const Plane& pl);
bool operator!=(const Plane& pl, const Point3& pt);
bool operator!=(const Point3& pt, const Plane& pl);
bool operator<(const Plane& pl, const Point3& pt);
bool operator<(const Point3& pt, const Plane& pl);
bool operator<=(const Plane& pl, const Point3& pt);
bool operator<=(const Point3& pt, const Plane& pl);
bool operator>(const Plane& pl, const Point3& pt);
bool operator>(const Point3& pt, const Plane& pl);
bool operator>=(const Plane& pl, const Point3& pt);
bool operator>=(const Point3& pt, const Plane& pl);



#endif
