/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef POINT3H
#define POINT3H

#include <stdio.h>

#include "Vector3.h"


class Point3
{
public:
	double x, y, z;


	Point3();
	Point3(double ix, double iy, double iz);
	Point3(const Vector3& v);


	void read(FILE *f);
	void write(FILE *f) const;

	

	bool operator==(const Point3& p) const;
	bool operator!=(const Point3& p) const;

	Point3 operator+(const Vector3& v) const;
	Point3& operator+=(const Vector3& v);
	Point3 operator-(const Vector3& v) const;
	Point3& operator-=(const Vector3& v);
	Vector3 operator-(const Point3& v) const;

	Vector3 toVector3() const;

	double dotProduct(const Vector3& v) const;
	double distanceSquared(const Point3& p) const;
	double distanceTo(const Point3& p) const;
};



#endif
