/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef VALUESNAPCPP
#define VALUESNAPCPP

#include "ValueSnap.h"


/*
*******************************************************************************
												ValueSnap
*******************************************************************************
*/


//default constructor
ValueSnap::ValueSnap()
{
	granularity = 0.0;
}

//constructor. Negate negative values
ValueSnap::ValueSnap(double g)
{
	if (g >= 0.0)
	{
		granularity = g;
	}
	else
	{
		granularity = -g;
	}
}

//snap a value
double ValueSnap::snap(double v) const
{
	if (granularity == 0.0)		//if the gran is 0.0
	{
		return v;					//leave the number inchanged
	}
	else
	{
		//round up or down to the nearest granularity unit
		int m;
		//deal with the fact that the fpu rounds +ve numbers down,
		//and -ve numbers up
		if (v > 0)
		{
			m = (int)((v / granularity) + 0.5);
		}
		else
		{
			m = (int)((v / granularity) - 0.5);
		}
		return m * granularity;
	}
}


#endif
