/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef VECTORSNAPCPP
#define VECTORSNAPCPP

#include "VectorSnap.h"



/*
*******************************************************************************
												VectorSnap
*******************************************************************************
*/

VectorSnap::VectorSnap()
{
	xsnap = ValueSnap();
	ysnap = ValueSnap();
	zsnap = ValueSnap();
}

VectorSnap::VectorSnap(const Vector3& g)
{
	xsnap = ValueSnap(g.x);
	ysnap = ValueSnap(g.y);
	zsnap = ValueSnap(g.z);
}

Vector3 VectorSnap::snap(const Vector3& v) const
{
	return Vector3( xsnap.snap(v.x),
						 ysnap.snap(v.y),
						 zsnap.snap(v.z) );
}

Point3 VectorSnap::snap(const Point3& v) const
{
	return Point3( xsnap.snap(v.x),
						ysnap.snap(v.y),
						zsnap.snap(v.z) );
}


#endif
