/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef VIEWFRUSTRUMH
#define VIEWFRUSTRUMH

#include "array.h"

#include "Point3.h"
#include "Vector3.h"
#include "Line3.h"
#include "Plane.h"
#include "Matrix4.h"



class ViewFrustrum
{
private:
	array<Plane> pl;

public:
	ViewFrustrum();
	ViewFrustrum(const Vector3& viewDirection, const array<Point3>& corners);
	ViewFrustrum(const array<Plane>& planes);


	bool checkPoint(const Point3& p) const;
	long pointBitList(const Point3& p) const;


	bool clip(Line3& l) const;


	friend ViewFrustrum operator*(ViewFrustrum f, const Matrix4& m);
};


ViewFrustrum operator*(ViewFrustrum f, const Matrix4& m);



#endif
