/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef POLARCPP
#define POLARCPP

#include <math.h>

#include "polar.h"

#ifndef RADTODEG
#define RADTODEG(x) x * 180.0 / M_PI
#endif

#ifndef DEGTORAD
#define DEGTORAD(x) x * M_PI / 180.0
#endif



double arg_polar(double x, double y)
{
	if (x == 0.0)
	{
		if (y > 0.0)
		{
			return M_PI * 0.5;
		}
		else if (y < 0.0)
		{
			return M_PI * 1.5;
		}
		else
		{
			return 0.0;
		}
	}

	double a = atan( y / x );

	if (a < 0.0)
	{
		a += M_PI;
	}

	if (y < 0.0)
	{
		a -= M_PI;
	}

	return a;
	
}


double abs_polar(double x, double y)
{
	return sqrt( x * x + y * y );
}



#endif
