/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __JOURNALMESH_CPP
#define __JOURNALMESH_CPP

#include "JournalMesh.h"



void* __create_JournalMesh()
{
	return (void*)( new JournalMesh() );
}

ObjectType type_JournalMesh("JournalMesh", "JournalModel",
									 __create_JournalMesh);




JournalMesh::JournalMesh() : JournalModel()
{
	mesh = new CMesh();
}

JournalMesh::JournalMesh(const CMesh& m) : JournalModel()
{
	mesh = new CMesh();
	*mesh = m;
}	

JournalMesh::~JournalMesh()
{
}


string JournalMesh::getDescription() const
{
	return "Mesh";
}

const ObjectType* JournalMesh::getType() const
{
	return &type_JournalMesh;
}

const ObjectType* JournalMesh::getTypeStatic()
{
	return &type_JournalMesh;
}


JournalObject* JournalMesh::clone() const
{
	return new JournalMesh(*mesh);
}

void JournalMesh::copyFrom(const JournalObject *o)
{
	JournalMesh *other = (JournalMesh*)o;
	mesh->copyFrom( other->mesh );
}




CModel* JournalMesh::getModel()
{
	return mesh;
}

const CModel* JournalMesh::getModel() const
{
	return mesh;
}




CMesh* JournalMesh::getMesh()
{
	return mesh;
}

const CMesh* JournalMesh::getMesh() const
{
	return mesh;
}



#endif
