/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __JOURNALMESH_H
#define __JOURNALMESH_H

#include "JournalObject.h"
#include "CVertexContainer.h"
#include "CMesh.h"
#include "JournalModel.h"




class JournalMesh : public JournalModel
{
protected:
	CMesh *mesh;
	
public:
	JournalMesh();
protected:
	JournalMesh(const CMesh& m);
public:
	virtual ~JournalMesh();

	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();
	
	virtual JournalObject* clone() const;
	virtual void copyFrom(const JournalObject *o);


	virtual CModel* getModel();
	virtual const CModel* getModel() const;

	CMesh* getMesh();
	const CMesh* getMesh() const;
};



#endif
