/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		02/Jul/1999
	title:				Model painter
*/
#ifndef __MESHPAINTER_H
#define __MESHPAINTER_H

#include "JournalObject.h"
#include "JournalMesh.h"
#include "CMesh.h"
#include "CadArea.h"
#include "CVertex.h"
#include "ObjectPainter.h"


class MeshPainter : public ObjectPainter
{
private:
	CMesh *mesh;

public:
	MeshPainter(CadArea *c);

	void setMesh(CMesh *m);
	virtual void setObject(JournalObject *o);


	virtual ObjectPainter* clone();


	virtual void paint();

	void drawMesh();
	void drawEdge(const CEdge *edge, CadArea *ar, const CVertexContainer& v);
};


#endif
