/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLKITMESH_CPP
#define __TOOLKITMESH_CPP

#include "ToolkitMesh.h"



ToolkitMesh::ToolkitMesh(Toolbox *tbx, CadView *view,
								 JournalEditor *journalEditor,
								 ProcessToolManager *toolManager,
								 ObjPainterManager *painterManager)
								 : MToolkit(tbx)
{
	meshToolset = new ToolsetMesh(tbox, view, journalEditor,
											toolManager, painterManager);
}

ToolkitMesh::~ToolkitMesh()
{
	delete meshToolset;
}


void ToolkitMesh::install()
{
	MToolkit::install();
	tbox->addToolset( meshToolset->getWidget(), "Mesh" );
}

void ToolkitMesh::uninstall()
{
	MToolkit::uninstall();
	tbox->removeToolset( meshToolset->getWidget() );
}


#endif
