/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLSETMESH_CPP
#define __TOOLSETMESH_CPP

#include "ToolsetMesh.h"

#include <gtk/gtkbutton.h>
#include <gtk/gtksignal.h>
#include <gtk/gtklabel.h>



ToolsetMesh::ToolsetMesh(Toolbox *tbx, CadView *view,
								 JournalEditor *histEditor,
								 ProcessToolManager *toolManager,
								 ObjPainterManager *painterManager)
								 : Toolset("---Mesh---", tbx)
{
	xformGroup = new ToolGroupXform(toolManager, histEditor,
											  view, painterManager);

	selectGroup = new ToolGroupSelect(toolManager, histEditor,
												 view, painterManager);


	xformGroup->addToLayout(&layout);
	layout.lineSpace(1);
	selectGroup->addToLayout(&layout);
}

ToolsetMesh::~ToolsetMesh()
{
	delete xformGroup;
	delete selectGroup;
}



#endif
