/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by :					Geoffrey French
	application :		gSculpt
	last revision :	08/Jul/2000
	title :				Model
	puspose :			Abstract Model Class
*/
#ifndef __CMODEL_H
#define __CMODEL_H



#include "Transformation.h"
#include "Matrix4.h"
#include "BBox.h"
#include "SelectPredicate.h"
#include "SelectRegion.h"


/*
*******************************************************************************
												CModel
*******************************************************************************
*/



class CModel
{
public:
	CModel();


	virtual void read(FILE *f);
	virtual void write(FILE *fh) const;
	
	
	virtual void transform(const Matrix4& m, bool selectedOnly = true);
	virtual void transform(const Transformation *x, bool selectedOnly = true);
	virtual void transformBackup(bool selectedOnly = true);
	virtual void transformRestore();

	virtual void select(SelectPredicate predicate, const SelectRegion *region);
	virtual void selectBackup();
	virtual void selectRestore();

	virtual BBox getBBox(bool selectedOnly = true) const;
	virtual BBox getBBox(const Matrix4& m, bool selectedOnly = true) const;
	virtual BBox getBBox(const Transformation *x, bool selectedOnly = true) const;
};



#endif
