/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLMODIFYMODEL_CPP
#define __TOOLMODIFYMODEL_CPP

#include "ToolModifyModel.h"
#include "JournalProcess.h"




ToolModifyModel::ToolModifyModel(CadView *v,
											ObjPainterManager *pman,
											const string& funcName,
											const string& optTitle,
											int tableWidth)
											: ProcessTool( v, funcName, optTitle,
							  									tableWidth )
{
	painterManager = pman;
}

ToolModifyModel::~ToolModifyModel()
{
}



bool ToolModifyModel::hasOwnPainter() const
{
	return true;
}




void ToolModifyModel::initialise()
{
	ProcessTool::initialise();
	painter = painterManager->createPainter( journalObject->getType() );

	JournalModel *jModel = (JournalModel*)journalObject;
	backupModel(jModel);

	JournalObject *o = journalProcess->process(journalObject, NULL);

	painter->setObject(o);
	view->addEventHandler(painter);

	view->redraw();
}

void ToolModifyModel::shutdown()
{
	ProcessTool::shutdown();
	view->removeEventHandler(painter);
	delete painter;
}


void ToolModifyModel::modified()
{
	ProcessTool::modified();

	updateView();
}



void ToolModifyModel::updateView()
{
	JournalModel *jModel = (JournalModel*)journalObject;
	restoreModel(jModel);
	
	JournalObject *o = journalProcess->process(journalObject, NULL);

	painter->setObject(o);

	view->redraw();
}


void ToolModifyModel::backupModel(JournalModel *model)
{
}

void ToolModifyModel::restoreModel(JournalModel *model)
{
}


#endif
