/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLMODIFYMODEL_H
#define __TOOLMODIFYMODEL_H


#include <string>


#include "ObjPainterManager.h"
#include "ObjectPainter.h"
#include "ProcessTool.h"
#include "JournalModel.h"





class ToolModifyModel : public ProcessTool
{
protected:
	ObjPainterManager *painterManager;
	ObjectPainter *painter;


public:
	ToolModifyModel(CadView *v, ObjPainterManager *pman,
						 const string& funcName, const string& optTitle,
						 int tableWidth = 1);
	virtual ~ToolModifyModel();


	virtual bool hasOwnPainter() const;


protected:
	virtual void initialise();
	virtual void shutdown();

	virtual void modified();

	void updateView();

	virtual void backupModel(JournalModel *model);
	virtual void restoreModel(JournalModel *model);
};



#endif
