/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __MULTITHREADING_H
#define __MULTITHREADING_H

#include <glib.h>



void initThreads();

void newThread(GHookFunc func, gpointer data);



class GSCMutex
{
private:
	GMutex *mutex;

public:
	GSCMutex();
	~GSCMutex();

	void lock();
	void unlock();

	friend class GSCCond;
};


class GSCCond
{
private:
	GCond *cond;

public:
	GSCCond();
	~GSCCond();

	void signal();
	void wait(GSCMutex *mutex);
};



#endif
