/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		29/Jun/1999
	title:				Background Object Manager
*/
#ifndef __BACKGROUNDOBJMANAGER_H
#define __BACKGROUNDOBJMANAGER_H

#include <string>
#include <map>

#include "Journal.h"
#include "JournalObject.h"
#include "ObjectPainter.h"
#include "ObjPainterManager.h"
#include "CadView.h"



class BackgroundObjManager
{
private:
	CadView *view;
	ObjPainterManager *painterManager;

	class Entry
	{
	private:
		Journal *journal;
		JournalObject *journalObject;
		bool activeFlag;
		ObjectPainter *painter;


	public:
		Entry(Journal *journ, ObjPainterManager *painterManager);
		~Entry();

		void activate(CadView *view);
		void deactivate(CadView *view);
		void update(ObjPainterManager *painterManager,
						CadView *view, bool redrawFlag);
	};

	map<string,Entry*> entries;


public:
	BackgroundObjManager(CadView *vw, ObjPainterManager *pManager);


	bool exists(const string& objName);
	void add(const string& objName, Journal *journ, bool active = true);
	void remove(const string& objName);
	void activate(const string& objName);
	void deactivate(const string& objName);
	void update(const string& objName);
	void updateAll();
};


#endif
