/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		24/Jun/2000
*/
#ifndef __COBJECTEDITOR_H
#define __COBJECTEDITOR_H

#include <string>

#include "CadEditor.h"

#include "ObjectCollection.h"

#include "Toolset.h"
#include "ToolsetObjectEdit.h"
#include "ToolsetView.h"

#include "ToolkitCreateObject.h"
#include "ToolkitPolyline.h"
#include "ToolkitMesh.h"

#include "ObjPainterManager.h"
#include "PolylinePainter.h"
#include "MeshPainter.h"

#include "ProcessToolManager.h"





class CObjectEditor : public CadEditor
{
private:
	ToolsetObjectEdit *objectEditorToolset;
	ObjectCollection *objects;
	CadView *view;

	ToolsetView *viewToolset;

	ToolkitCreateObject *createObjectToolkit;
	ToolkitPolyline *polylineToolkit;
	ToolkitMesh *meshToolkit;

	ObjPainterManager *painterManager;
	PolylinePainter *polyPainter;
	MeshPainter *meshPainter;


	ProcessToolManager *toolMan;


public:
	CObjectEditor(const string& wintitle, ObjectCollection *objColl,
					  GtkSignalFunc closeCallbackFunc, gpointer closeCallbackData);
	virtual ~CObjectEditor();

protected:
	virtual void shutdown();	
};



#endif
