/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __OBJPAINTERMANAGER_CPP
#define __OBJPAINTERMANAGER_CPP

#include "ObjPainterManager.h"




ObjPainterManager::ObjPainterManager()
{
}


void ObjPainterManager::addPainter(const ObjectType* type, ObjectPainter *painter)
{
	if ( eventHandlers.count( type->getId() ) == 0 )
	{
		eventHandlers[ type->getId() ] = painter;
	}
}

ObjectPainter* ObjPainterManager::createPainter(const ObjectType* type)
{
	if ( eventHandlers.count( type->getId() ) > 0 )
	{
		return eventHandlers[ type->getId() ]->clone();
	}
	else
	{
		return NULL;
	}
}


#endif
