/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __PATCH_CPP
#define __PATCH_CPP

#include "Patch.h"


void patchGenerateQuadsAcross(vector<int>& quads, int row0Offset, int row1Offset,
										int widthVertices, bool wrap)
{
	for (int i = 1; i < widthVertices; i++)
	{
		quads.push_back( row0Offset + i - 1 );
		quads.push_back( row0Offset + i );
		quads.push_back( row1Offset + i );
		quads.push_back( row1Offset + i - 1 );
	}

	if ( wrap )
	{
		quads.push_back( row0Offset + widthVertices - 1 );
		quads.push_back( row0Offset );
		quads.push_back( row1Offset );
		quads.push_back( row1Offset + widthVertices - 1 );
	}
}


void patchGenerateQuadList(vector<int>& quads, int widthFaces, int heightFaces,
									bool wWrap, bool hWrap)
{
	int widthVertices = wWrap ? widthFaces : widthFaces + 1;
	int heightVertices = hWrap ? heightFaces : heightFaces + 1;
	
	quads.reserve( widthFaces * heightFaces << 2 );

	int offset = 0;
	for (int i = 1; i < heightVertices; i++)
	{
		patchGenerateQuadsAcross( quads, offset, offset + widthVertices,
										  widthVertices, wWrap );

		offset += widthVertices;
	}

	if (hWrap)
	{
		patchGenerateQuadsAcross( quads, offset, 0,
										  widthVertices, wWrap );
	}
}



#endif
