/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef CPOLYLINECPP
#define CPOLYLINECPP

#include <unistd.h>

#include "CPolyline.h"



/*
*******************************************************************************
											CPolyline
*******************************************************************************
*/



CPolyline::CPolyline() : CModel()
{
	poly_closed = true;
}

/*CPolyline::CPolyline(const CPolyline& p) : CModel()
{
	map<const CVertex*, CVertex*> vertexMapping;

	poly_closed = p.poly_closed;
	v.duplicate( p.v, vertexMapping );
}*/

CPolyline::~CPolyline()
{
}



/*CPolyline& CPolyline::operator=(const CPolyline& p)
{
	map<const CVertex*, CVertex*> vertexMapping;

	poly_closed = p.poly_closed;
	v.duplicate( p.v, vertexMapping );

	return *this;
}*/


void CPolyline::read(FILE *f)
{
	v.read(f);
	fread(&poly_closed, sizeof(bool), 1, f);
}

void CPolyline::write(FILE *f) const
{
	v.write(f);
	fwrite(&poly_closed, sizeof(bool), 1, f);
}


CVertex* CPolyline::addVertex(const Point3& location, bool marked)
{
	v.push_back( CVertex(location) );

	if (marked)
	{
		v.back().mark();
	}
	
	return &v.back();
}

CVertex* CPolyline::addVertexAt(int position, const Point3& location,
										  bool marked)
{
	v.insert(position);
	v[position] = CVertex(location);

	if (marked)
	{
		v[position].mark();
	}
	
	return &( v[position] );
}

void CPolyline::removeVertex(CVertex *vtx)
{
	for (CVertexContainer::iterator iter = v.begin();
		  iter != v.end();
		  ++iter)
	{
		if (&(*iter) == vtx)
		{
			v.erase(iter);
			return;
		}
	}
}

void CPolyline::swapVertices(CVertex *a, CVertex *b)
{
	CVertex swap = *a;
	*a = *b;
	*b = swap;
}


void CPolyline::reserveVertices(int s)
{
	v.reserve(s);
}


void CPolyline::close()
{
	poly_closed = true;
}

void CPolyline::open()
{
	poly_closed = false;
}

void CPolyline::setClosed(bool c)
{
	poly_closed = c;
}

bool CPolyline::isClosed() const
{
	return poly_closed;
}


void CPolyline::copyFrom(const CPolyline *p)
{
	v.copyFrom( &(p->v) );
	poly_closed = p->poly_closed;
}



int CPolyline::getNumberOfVertices() const
{
	return v.size();
}



CVertexContainer& CPolyline::vertices()
{
	return v;
}

const CVertexContainer& CPolyline::vertices() const
{
	return v;
}


void CPolyline::transform(const Matrix4& m, bool selectedOnly)
{
	v.transform(m, selectedOnly);
}

void CPolyline::transform(const Transformation *x, bool selectedOnly)
{
	v.transform(x, selectedOnly);
}

void CPolyline::transformBackup(bool selectedOnly)
{
	xformBak = v.backup(selectedOnly);
}

void CPolyline::transformRestore()
{
	v.restore(xformBak);
}


void CPolyline::select(SelectPredicate predicate, const SelectRegion *region)
{
	v.select( predicate, region );
}

void CPolyline::selectBackup()
{
	selectBak = v.backup(false);
}

void CPolyline::selectRestore()
{
	v.restore(selectBak);
}


BBox CPolyline::getBBox(bool selectedOnly) const
{
	return v.getBBox(selectedOnly);
}

BBox CPolyline::getBBox(const Matrix4& m, bool selectedOnly) const
{
	return v.getBBox(m, selectedOnly);
}

BBox CPolyline::getBBox(const Transformation *x, bool selectedOnly) const
{
	return v.getBBox(x, selectedOnly);
}





#endif
