/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __JOURNALPOLYLINE_CPP
#define __JOURNALPOLYLINE_CPP

#include "JournalPolyline.h"




void* __create_JournalPolyline()
{
	return (void*)( new JournalPolyline() );
}

ObjectType type_JournalPolyline( "JournalPolyline", "JournalModel",
											__create_JournalPolyline );




JournalPolyline::JournalPolyline() : JournalModel()
{
	poly = new CPolyline();
}

JournalPolyline::JournalPolyline(const CPolyline& p) : JournalModel()
{
	poly = new CPolyline();
	*poly = p;
}	

JournalPolyline::~JournalPolyline()
{
}


string JournalPolyline::getDescription() const
{
	return "Polyline";
}

const ObjectType* JournalPolyline::getType() const
{
	return &type_JournalPolyline;
}

const ObjectType* JournalPolyline::getTypeStatic()
{
	return &type_JournalPolyline;
}


JournalObject* JournalPolyline::clone() const
{
	return new JournalPolyline(*poly);
}

void JournalPolyline::copyFrom(const JournalObject *o)
{
	JournalPolyline *other = (JournalPolyline*)o;
	poly->copyFrom( other->poly );
}




CModel* JournalPolyline::getModel()
{
	return poly;
}

const CModel* JournalPolyline::getModel() const
{
	return poly;
}




CPolyline* JournalPolyline::getPoly()
{
	return poly;
}

const CPolyline* JournalPolyline::getPoly() const
{
	return poly;
}



#endif
