/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __JOURNALPOLYLINE_H
#define __JOURNALPOLYLINE_H

#include "JournalObject.h"
#include "CVertexContainer.h"
#include "CPolyline.h"
#include "JournalModel.h"




class JournalPolyline : public JournalModel
{
protected:
	CPolyline *poly;
	
public:
	JournalPolyline();
protected:
	JournalPolyline(const CPolyline& p);
public:
	virtual ~JournalPolyline();

	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();
	
	virtual JournalObject* clone() const;
	virtual void copyFrom(const JournalObject *o);


	virtual CModel* getModel();
	virtual const CModel* getModel() const;


	CPolyline* getPoly();
	const CPolyline* getPoly() const;
};



#endif
