/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLKITPOLYLINE_CPP
#define __TOOLKITPOLYLINE_CPP

#include "ToolkitPolyline.h"



ToolkitPolyline::ToolkitPolyline(Toolbox *tbx, CadView *view,
											JournalEditor *journalEditor,
											ProcessToolManager *toolManager,
											ObjPainterManager *painterManager)
											: MToolkit(tbx)
{
	polylineToolset = new ToolsetPolyline( tbox, view, journalEditor,
														toolManager, painterManager );
}

ToolkitPolyline::~ToolkitPolyline()
{
	delete polylineToolset;
}


void ToolkitPolyline::install()
{
	MToolkit::install();
	tbox->addToolset( polylineToolset->getWidget(), "Polyline" );
}

void ToolkitPolyline::uninstall()
{
	MToolkit::uninstall();
	tbox->removeToolset( polylineToolset->getWidget() );
}


#endif
