/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLSETPOLYLINE_CPP
#define __TOOLSETPOLYLINE_CPP

#include "ToolsetPolyline.h"

#include <gtk/gtkbutton.h>
#include <gtk/gtksignal.h>
#include <gtk/gtklabel.h>



ToolsetPolyline::ToolsetPolyline(Toolbox *tbx, CadView *view,
											JournalEditor *histEditor,
											ProcessToolManager *toolManager,
											ObjPainterManager *painterManager)
											: Toolset("---Polyline---", tbx)
{
	xformGroup = new ToolGroupXform(toolManager, histEditor,
											  view, painterManager);

	selectGroup = new ToolGroupSelect(toolManager, histEditor,
												 view, painterManager);

	polyGroup = new ToolGroupPolyline(toolManager, histEditor,
												 view, painterManager);

	loftGroup = new ToolGroupLoftPoly(toolManager, histEditor,
												 view, painterManager);


	xformGroup->addToLayout(&layout);
	layout.lineSpace(1);
	selectGroup->addToLayout(&layout);
	layout.lineSpace(1);
	polyGroup->addToLayout(&layout);
	layout.lineSpace(1);
	loftGroup->addToLayout(&layout);
}

ToolsetPolyline::~ToolsetPolyline()
{
	delete xformGroup;
	delete selectGroup;
	delete loftGroup;
	delete polyGroup;
}


#endif
