/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPPOLYLINE_H
#define __TOOLGROUPPOLYLINE_H

#include <gtk/gtkwidget.h>

#include "MToolGroup.h"

#include "ToolPolyDraw.h"
#include "ToolPolyPolygon.h"
#include "ToolPolySubdivide.h"
#include "ToolPolyDelete.h"
#include "ToolPolyReorder.h"
#include "JournalEditor.h"

#include "CadView.h"
#include "Toolbox.h"
#include "ObjPainterManager.h"



class ToolGroupPolyline : public MToolGroup
{
private:
	JournalEditor *journalEditor;

	GtkWidget *titleLabel;
	GtkWidget *drawButton, *polygonButton, *subdivideButton,
				 *deleteButton, *reorderButton;

	ToolPolyDraw *toolDraw;
	ToolPolyPolygon *toolPolygon;
	ToolPolySubdivide *toolSubdivide;
	ToolPolyDelete *toolDelete;
	ToolPolyReorder *toolReorder;
	

public:
	ToolGroupPolyline(ProcessToolManager *toolManager,
							JournalEditor *journEditor, CadView *view,
							ObjPainterManager *painterManager);
	virtual ~ToolGroupPolyline();


	virtual void addToLayout(GridLayout *layout);


private:
	static void drawClicked(GtkWidget *widget, ToolGroupPolyline *klass);
	static void polygonClicked(GtkWidget *widget, ToolGroupPolyline *klass);
	static void subdivideClicked(GtkWidget *widget, ToolGroupPolyline *klass);
	static void deleteClicked(GtkWidget *widget, ToolGroupPolyline *klass);
	static void reorderClicked(GtkWidget *widget, ToolGroupPolyline *klass);
};



#endif
