/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLPOLYDELETE_H
#define __TOOLPOLYDELETE_H

#include <gtk/gtkwidget.h>
#include <gtk/gtkobject.h>

#include <string>


#include "JournalProcess.h"
#include "ProcessTool.h"



class ProcPolyDelete : public JournalProcess
{
public:
	ProcPolyDelete();
	virtual ~ProcPolyDelete();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual const ObjectType* getInputType() const;

	virtual JournalProcess* clone() const;

protected:
	virtual const ObjectType* _getOutputType(const ObjectType* inputType) const;
	virtual JournalObject* _process(JournalObject *o,
											  JournalTaskProgress *progress);
};




class ToolPolyDelete : public ProcessTool
{
private:
	GtkWidget *doneButton;

public:
	ToolPolyDelete(CadView *v);
	~ToolPolyDelete();


	virtual const ObjectType* getProcessType() const;


private:
	static void doneClicked(GtkWidget *widget, ToolPolyDelete *klass);
};


#endif
