/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __SELECTPREDICATE_CPP
#define __SELECTPREDICATE_CPP

#include "SelectPredicate.h"




const char* __predicateNameStrings[] =
	{ "Or", "Select", "And", "Invert", "Unsel" };
	

const char* getNameOfSelectPredicate(SelectPredicate predicate)
{
	return __predicateNameStrings[predicate];
}

int getNumberOfSelectPredicates()
{
	return 5;
}

bool selectPredicateIsSelected( SelectPredicate predicate,
										  bool alreadySelected, bool isInRegion)
{
	switch(predicate)
	{
	case SELECTPREDICATE_OR:
		return alreadySelected || isInRegion;
	case SELECTPREDICATE_SELECT:
		return isInRegion;
	case SELECTPREDICATE_AND:
		return alreadySelected && isInRegion;
	case SELECTPREDICATE_INVERT:
		return (!alreadySelected && isInRegion) ||
				 (alreadySelected && !isInRegion);
	case SELECTPREDICATE_UNSELECT:
		return alreadySelected && !isInRegion;
	default:
		return alreadySelected || isInRegion;
	}
}



#endif
