/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPSELECT_H
#define __TOOLGROUPSELECT_H

#include <gtk/gtkwidget.h>

#include "MToolGroup.h"

#include "ToolSelectRectangular.h"
#include "ToolSelectCircular.h"
#include "ToolSelectAll.h"
#include "JournalEditor.h"

#include "CadView.h"
#include "Toolbox.h"
#include "ObjPainterManager.h"



class ToolGroupSelect : public MToolGroup
{
private:
	JournalEditor *journalEditor;

	GtkWidget *titleLabel;
	GtkWidget *rectButton, *circButton, *selButton,
				 *invButton, *unselButton;

	ToolSelectRectangular *toolRect;
	ToolSelectCircular *toolCirc;
	ToolSelectAll *toolSelectAll;
	

public:
	ToolGroupSelect(ProcessToolManager *toolManager,
						 JournalEditor *journEditor, CadView *view,
						 ObjPainterManager *painterManager);
	virtual ~ToolGroupSelect();


	virtual void addToLayout(GridLayout *layout);


private:
	static void rectClicked(GtkWidget *widget, ToolGroupSelect *klass);
	static void circClicked(GtkWidget *widget, ToolGroupSelect *klass);
	static void selClicked(GtkWidget *widget, ToolGroupSelect *klass);
	static void invClicked(GtkWidget *widget, ToolGroupSelect *klass);
	static void unselClicked(GtkWidget *widget, ToolGroupSelect *klass);
};



#endif
