/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLSELECTALL_H
#define __TOOLSELECTALL_H


#include <string>



#include "ToolSelectBase.h"



class ProcSelectAll : public ProcSelectBase
{
public:
	ProcSelectAll();
	ProcSelectAll(SelectPredicate pred);
	virtual ~ProcSelectAll();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual JournalProcess* clone() const;

protected:
	virtual void selectInModel(JournalModel *model) const;
};



class ToolSelectAll : public ToolSelectModel
{
private:
	GtkWidget *functionLabel;
	GtkWidget *doneButton;

public:
	ToolSelectAll(CadView *v, ObjPainterManager *pman);
	virtual ~ToolSelectAll();


	virtual const ObjectType* getProcessType() const;


protected:
	virtual void initialise();


private:
	static void doneClicked(GtkWidget *widget, ToolSelectAll *klass);
};



#endif
