/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by :					Geoffrey French
	application :		gSculpt
	last revision :	16/Apr/2000
	title :				backup template class
	purpose :			Provides a method of backing up an object and restoring
							the contents

  The backup template class stores a pointer to the original object, and the
  copy. When the restore() function is called, the object at the end of the
  pointer is assigned to the copy.
*/


#ifndef BACKUPH
#define BACKUPH


/*
*******************************************************************************
												backup
*******************************************************************************
*/


template <class T>
	class backup
{
private:
	T *source;				//pointer to the source object
	T copy;					//the copy object

public:
	backup()					//default constructor
	{
		source = NULL;		//assign NULL to the source ptr
		copy = T();			//use copy object's default constructor
	}

	backup(T *src)			//constructor
	{
		source = src;		//assign the source ptr
		copy = *source;	//take a copy
	}


	void restore()			//restore
	{
		*source = copy;	//copy the copy to the object at the end of source
	}
};


#endif
