/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by :					Geoffrey French
	application :		gSculpt
	last revision :	16/Apr/2000
	title :				backup list
	purpose : 			backup a list of objects

  Inherits from the list template class in the STL.
*/


#ifndef BACKUPLISTH
#define BACKUPLISTH

#include "backup.h"
#include <list>
#include <set>


/*
*******************************************************************************
											backuplist
*******************************************************************************
*/


template <class T>
	class backuplist : public list<backup<T> >
{
public:
	backuplist() : list<backup<T> >()			//default constructor; do nothing
	{
	}

	backuplist(list<T*>& l) : list<backup<T> >()	//constructor; backup list
	{
		for (list<T*>::iterator iter = l.begin();		//walk through list
			  iter != l.end();
			  ++iter)
		{
			push_back( backup<T>( *iter ) );				//backup each element
		}
	}

	backuplist(set<T*>& l) : list<backup<T> >()	//constructor; backup list from set
	{
		for (set<T*>::iterator iter = l.begin();		//walk through list
			  iter != l.end();
			  ++iter)
		{
			push_back( backup<T>( *iter ) );				//backup each element
		}
	}


	void restore()				//restore
	{
		for (iterator iter = begin(); iter != end(); ++iter)	//walk through
		{
			(*iter).restore();								//restore each element
		}
	}
};


#endif