/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		16/Apr/2000
*/
#ifndef CALLBACKH
#define CALLBACKH

#include <stdio.h>







template <class SOURCE, class DAT, class RET>
	class callback
{
private:
	class Response
	{
	};

public:
	typedef RET (Response::*Func)(SOURCE *src, DAT data);

private:
	Response *d;
	Func f;
	DAT data;

public:
	callback()
	{
		f = NULL;
	}
	
	callback(void *destination, Func fn, DAT dt)
	{
		d = (Response*)destination;
		f = fn;
		data = dt;
	}


	RET call(SOURCE *s)
	{
		if (f)
		{
			return ( (d)->*(f) )(s, data);
		}
		else
		{
			return RET();
		}
	}

	RET call(SOURCE *s, DAT dt)
	{
		if (f)
		{
			return ( (d)->*(f) )(s, dt);
		}
		else
		{
			return RET();
		}
	}
};



#endif
