/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		16/Apr/2000
*/
#ifndef DUALITERATORH
#define DUALITERATORH




template <class I, class cI, class ncI> class dualiterator
{
public:
	typedef dualiterator<I, cI, ncI> self;
	typedef dualiterator<cI, cI, ncI> cself;
	typedef dualiterator<ncI, cI, ncI> ncself;

	
	I first, second;


	dualiterator()
	{
	}
	
	dualiterator(I f, I s)
	{
		first = f;
		second = s;
	}

	dualiterator(I it)
	{
		first = second = it;
	}


	bool operator==(const cself& cmp) const
	{
		return first == cmp.first && second == cmp.second;
	}

	bool operator==(const ncself& cmp) const
	{
		return first == cmp.first && second == cmp.second;
	}

	bool operator==(const cI& cmp) const
	{
		return second == cmp;
	}

	bool operator==(const ncI& cmp) const
	{
		return second == cmp;
	}


	bool operator!=(const cself& cmp) const
	{
		return first != cmp.first || second != cmp.second;
	}

	bool operator!=(const ncself& cmp) const
	{
		return first != cmp.first || second != cmp.second;
	}

	bool operator!=(const cI& cmp) const
	{
		return second != cmp;
	}

	bool operator!=(const ncI& cmp) const
	{
		return second != cmp;
	}


	self& operator++()
	{
		first = second;
		++second;
		return *this;
	}

	self operator++(int)
	{
		self tmp = *this;
		first = second;
		++second;
		return tmp;
	}

	self& operator--()
	{
		second = first;
		--first;
		return *this;
	}

	self operator--(int)
	{
		self tmp = *this;
		second = first;
		--first;
		return tmp;
	}
};




#endif
