/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		30/Aug/2000
*/
#ifndef __CADTOOLAXISCHOOSER_H
#define __CADTOOLAXISCHOOSER_H

#include <gtk/gtkwidget.h>

#include "GridLayout.h"
#include "Vector3.h"
#include "Axes3.h"



class CadToolAxisChooser
{
public:
	typedef enum {
		AXIS,
		PLANE
	} LabelTexts;
	
private:
	GtkWidget *titleLabel;
	GtkWidget *radioButtons[3];
	Axis axis;
	GtkSignalFunc sigFunc;
	gpointer sigFuncData;

	void emitSignal(GtkWidget *widget);
	static void radioXClicked(GtkWidget *widget, CadToolAxisChooser *klass);
	static void radioYClicked(GtkWidget *widget, CadToolAxisChooser *klass);
	static void radioZClicked(GtkWidget *widget, CadToolAxisChooser *klass);


public:
	CadToolAxisChooser(Axis initialChoice = AXIS_Z);
	CadToolAxisChooser(GtkSignalFunc func, gpointer data,
							 Axis initialChoice = AXIS_Z,
							 LabelTexts labelTexts = AXIS);
	~CadToolAxisChooser();

private:
	void constructorCommon(Axis initialChoice, LabelTexts labelTexts);

public:
	void connect(GtkSignalFunc func, gpointer data);
	void disconnect();

	void addToLayout(GridLayout& layout);

	void setChoice(Axis choice);
	Axis getChoice() const;

	GtkWidget* getWidget(int widgetNumber);
};



#endif
