/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		31/Aug/2000
*/
#ifndef __CADTOOLCENTRECHOOSER_H
#define __CADTOOLCENTRECHOOSER_H

#include <gtk/gtkwidget.h>

#include "Centre.h"
#include "GridLayout.h"



class CadToolCentreChooser
{
private:
	GtkWidget *titleLabel, *radioCentre, *radioOrigin;
	Centre centre;		//true = object centre, false = origin
	GtkSignalFunc sigFunc;
	gpointer sigFuncData;


public:
	CadToolCentreChooser();
	CadToolCentreChooser(GtkSignalFunc func, gpointer data);
	~CadToolCentreChooser();

private:
	void constructorCommon();

public:
	void connect(GtkSignalFunc func, gpointer data);
	void disconnect();

	void addToLayout(GridLayout& layout);

	void setChoice(Centre cen);
	Centre getChoice() const;

	GtkWidget* getWidget(Centre cen);

private:
	void emitSignal(GtkWidget *widget);
	static void centreClicked(GtkWidget *widget, CadToolCentreChooser *klass);
	static void originClicked(GtkWidget *widget, CadToolCentreChooser *klass);
};



#endif
