/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLAXIS_H
#define __TOOLAXIS_H


#include <string>


#include "Vector3.h"
#include "Axes3.h"
#include "ProcXform.h"
#include "CadToolAxisChooser.h"
#include "ProcessTool.h"



class ProcAxis : public JournalProcess
{
protected:
	Axis axis;
	
public:
	ProcAxis();
	ProcAxis(Axis a);
	virtual ~ProcAxis();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual JournalProcess* clone() const;


	void setAxis(Axis a);
	Axis getAxis() const;

protected:
	Axes3 getAxes() const;
};



class ToolAxis : public ProcessTool
{
protected:
	CadToolAxisChooser *axisChooser;


public:
	ToolAxis(CadView *v, const string& funcName, const string& optTitle,
				int tableWidth = 1,
				CadToolAxisChooser::LabelTexts labelTexts = CadToolAxisChooser::AXIS);
	virtual ~ToolAxis();


	virtual const ObjectType* getProcessType() const;

protected:
	virtual void initialise();


private:
	static void axisChanged(GtkWidget *widget, ToolAxis *klass);
};



#endif
