/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/************************
 Licensed under the terms
 and conditions described
 in the file 'COPYING'
 ************************
	by:					Geoffrey French
	application:		gSculpt
	last revision:		16/Apr/2000
*/
#ifndef CADTOOLAXESH
#define CADTOOLAXESH

#include <gtk/gtkradiobutton.h>
#include <gtk/gtklabel.h>
#include <gtk/gtksignal.h>

#include "GridLayout.h"
#include "CadArea.h"
#include "CadToolSection.h"

#include "Axes3.h"



class CadToolAxes : public CadToolSection
{
public:
	typedef enum {
		WORLDX,
		WORLDY,
		WORLDZ,
		SCREENX,
		SCREENY,
		SCREENZ
	} AxisNumber;
	
private:
	GtkWidget *cta_label, *cta_world, *cta_screen;
	GtkWidget *cta_wld_x, *cta_wld_y, *cta_wld_z;
	GtkWidget *cta_scr_x, *cta_scr_y, *cta_scr_z;
	Axes3 cta_rawAxes;
	bool cta_inScreenSpace;
	AxisNumber cta_num;

	static void world_x_clicked(GtkWidget *widget, CadToolAxes *klass);
	static void world_y_clicked(GtkWidget *widget, CadToolAxes *klass);
	static void world_z_clicked(GtkWidget *widget, CadToolAxes *klass);
	static void screen_x_clicked(GtkWidget *widget, CadToolAxes *klass);
	static void screen_y_clicked(GtkWidget *widget, CadToolAxes *klass);
	static void screen_z_clicked(GtkWidget *widget, CadToolAxes *klass);

public:
	CadToolAxes(AxisNumber defaultAxis = WORLDX);
	virtual ~CadToolAxes();

	virtual void addToGrid(GridLayout& gr);

	Axes3 getAxes(CadArea *ca) const;
	AxisNumber getAxisNumber() const;
};



#endif
