/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/************************
 Licensed under the terms
 and conditions described
 in the file 'COPYING'
 ************************
	by:					Geoffrey French
	application:		gSculpt
	last revision:		16/Apr/2000
*/
#ifndef CADTOOLCENTREH
#define CADTOOLCENTREH

#include <gtk/gtkradiobutton.h>
#include <gtk/gtklabel.h>
#include <gtk/gtksignal.h>

#include "GridLayout.h"
#include "CVertexList.h"
#include "CadToolSection.h"



class CadToolCentre : public CadToolSection
{
private:
	GtkWidget *ctc_label, *ctc_centre, *ctc_origin;
	bool ctc_centreFlag;		//true = object centre, false = origin

	static void centre_clicked(GtkWidget *widget, CadToolCentre *klass);
	static void origin_clicked(GtkWidget *widget, CadToolCentre *klass);


public:
	CadToolCentre();
	virtual ~CadToolCentre();

	virtual void addToGrid(GridLayout& gr);

	bool centreIsOrigin() const;
	bool centreIsObjectCentre() const;
	Point3 getCentre(const CVertexList& l) const;
};



#endif
