/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __PROCESSTOOL_CPP
#define __PROCESSTOOL_CPP


#include "ProcessTool.h"


/*
*******************************************************************************
											ProcessTool
*******************************************************************************
*/

ProcessTool::ProcessTool(CadView *v, const string& funcName,
								 const string& optTitle, int tableWidth)
								 : MTool(v, funcName, optTitle, tableWidth)
{
	journalProcess = NULL;
	journalObject = NULL;
}

ProcessTool::~ProcessTool()
{
}


const ObjectType* ProcessTool::getProcessType() const
{
	if ( hasProcess() )
	{
		return journalProcess->getType();
	}
	else
	{
		return NULL;
	}
}

bool ProcessTool::hasOwnPainter() const
{
	return false;
}


void ProcessTool::attachProcess(JournalProcess *p, JournalObject *o)
{
	journalProcess = p;
	journalObject = o;
}

void ProcessTool::detachProcess()
{
	journalProcess = NULL;
	journalObject = NULL;
}

bool ProcessTool::hasProcess() const
{
	return journalProcess != NULL;
}




#endif
