/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by :					Geoffrey French
	application :		gSculpt
	last revision :	29/Jun/2000
	title :				CAD Tool Base Class
*/
#ifndef __PROCESSTOOL_H
#define __PROCESSTOOL_H

#include <string>
#include <map>



#include "MTool.h"
#include "CadView.h"
#include "JournalProcess.h"
#include "JournalObject.h"


/*
*******************************************************************************
											ProcessTool
*******************************************************************************
*/


class ProcessTool : public MTool
{
protected:
	JournalProcess *journalProcess;
	JournalObject *journalObject;

public:
	ProcessTool(CadView *v, const string& funcName,
					const string& optTitle, int tableWidth = 1);
	virtual ~ProcessTool();


	virtual const ObjectType* getProcessType() const;
	virtual bool hasOwnPainter() const;


	void attachProcess(JournalProcess *p, JournalObject *o);
	void detachProcess();
	bool hasProcess() const;
};


#endif
