/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by :					Geoffrey French
	application :		gSculpt
	last revision :	29/Jun/2000
	title :				Tool Base Class
*/
#ifndef __PROCESSTOOLMANAGER_H
#define __PROCESSTOOLMANAGER_H

#include <string>
#include <map>

#include "ProcessTool.h"
#include "TypeManager.h"



class ProcessToolManagerToolInUseException
{
public:
	const ObjectType *t;

	ProcessToolManagerToolInUseException(const ObjectType *type);
};




class ProcessToolManager
{
private:
	struct Entry {
		ProcessTool *tool;
		bool lockFlag;
	};
	
	map<Typeid, Entry> tools;

public:
	ProcessToolManager();

	void addTool(const ObjectType *type, ProcessTool *tool);
	void eraseTool(const ObjectType *type);

	ProcessTool* takeTool(const ObjectType *type);
	void returnTool(const ObjectType *type);
};



#endif
