/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by :					Geoffrey French
	application :		gSculpt
	last revision :	29/Jun/2000
	title :				Tool Base Class
*/
#ifndef __TOOL_H
#define __TOOL_H

#include <string>

#include <gtk/gtkwidget.h>


#include "Geometry.h"
#include "Toolbox.h"
#include "GridLayout.h"


/*
*******************************************************************************
												Tool
*******************************************************************************
*/


class ToolListener
{
public:
	virtual void toolChanged();
	virtual void toolDone();
};


class Tool
{
private:
	GtkWidget *toolTable;
	GtkWidget *titleLabel;
	ToolListener *listener;
	Toolbox *currentToolbox;
	string functionName;

protected:
	GridLayout layout;

	
public:
	Tool(const string& funcName, const string& optTitle,
		  int tableWidth = 1);
	virtual ~Tool();

	void install(ToolListener *l, Toolbox *toolbox);
	void uninstall();

protected:
	virtual void initialise();
	virtual void shutdown();

	virtual void modified();
	void done();

private:
	void addToToolbox(Toolbox *toolbox);
	void removeFromToolbox(Toolbox *toolbox);
};



#endif

