/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUP_CPP
#define __TOOLGROUP_CPP

#include <gtk/gtkbutton.h>

#include "ToolGroup.h"



ToolGroup::ToolGroup()
{
}

ToolGroup::~ToolGroup()
{
	for (int i = 0; i < (int)toolButtons.size(); i++)
	{
		gtk_widget_unref( toolButtons[i] );
	}
}


void ToolGroup::addToLayout(GridLayout *layout)
{
}


GtkWidget* ToolGroup::addToolButton(const string& buttonText,
												GtkSignalFunc buttonClickedResponse)
{
	GtkWidget *button = gtk_button_new_with_label( buttonText.c_str() );
	gtk_widget_ref(button);
	gtk_signal_connect( GTK_OBJECT(button), "clicked",
							  GTK_SIGNAL_FUNC(buttonClickedResponse), this );
	gtk_widget_show(button);


	toolButtons.push_back(button);

	return button;
}




#endif
