/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		24/Jun/2000
*/
#ifndef __TOOLSET_H
#define __TOOLSET_H

#include <gtk/gtkwidget.h>

#include <string>
#include <vector>

#include "GridLayout.h"
#include "CadView.h"
#include "Toolbox.h"



class Toolset
{
protected:
	GtkWidget *toolTable;
	
private:
	GtkWidget *toolsetLabel;
	string toolsetName;

	vector<GtkWidget*> toolButtons;



	//code shared between constructors
	void constructorShared(const string& name = "");

protected:
	GridLayout layout;
	Toolbox *toolBox;


public:
	Toolset();
	Toolset(Toolbox *tbx);
	virtual ~Toolset();

	GtkWidget* getWidget();


	GtkWidget* addToolButton(const string& buttonText,
									 GtkSignalFunc buttonClickedResponse);
	

protected:
	Toolset(const string& name, Toolbox *tbx);
};



#endif
