/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLSETVIEW_CPP
#define __TOOLSETVIEW_CPP

#include "ToolsetView.h"

#include <gtk/gtkbutton.h>
#include <gtk/gtksignal.h>
#include <gtk/gtklabel.h>



ToolsetView::ToolsetView(Toolbox *tbx, CadView *vw)
								 : Toolset("---View---", tbx)
{
	addToolButton( "Top", GTK_SIGNAL_FUNC(topClicked) );
	addToolButton( "Front", GTK_SIGNAL_FUNC(frontClicked) );
	addToolButton( "Back", GTK_SIGNAL_FUNC(backClicked) );
	addToolButton( "Bottom", GTK_SIGNAL_FUNC(bottomClicked) );
	addToolButton( "Left", GTK_SIGNAL_FUNC(leftClicked) );
	addToolButton( "Right", GTK_SIGNAL_FUNC(rightClicked) );

	layout.lineSpace();

	addToolButton( "Origin", GTK_SIGNAL_FUNC(originClicked) );
	addToolButton( "1 to 1", GTK_SIGNAL_FUNC(oneToOneClicked) );

	view = vw;
}

ToolsetView::~ToolsetView()
{
}




void ToolsetView::topClicked(GtkWidget *widget, ToolsetView *klass)
{
	klass->view->getCadArea()->top();
	klass->view->redraw();
}

void ToolsetView::frontClicked(GtkWidget *widget, ToolsetView *klass)
{
	klass->view->getCadArea()->front();
	klass->view->redraw();
}

void ToolsetView::backClicked(GtkWidget *widget, ToolsetView *klass)
{
	klass->view->getCadArea()->back();
	klass->view->redraw();
}

void ToolsetView::bottomClicked(GtkWidget *widget, ToolsetView *klass)
{
	klass->view->getCadArea()->bottom();
	klass->view->redraw();
}

void ToolsetView::leftClicked(GtkWidget *widget, ToolsetView *klass)
{
	klass->view->getCadArea()->left();
	klass->view->redraw();
}

void ToolsetView::rightClicked(GtkWidget *widget, ToolsetView *klass)
{
	klass->view->getCadArea()->right();
	klass->view->redraw();
}


void ToolsetView::originClicked(GtkWidget *widget, ToolsetView *klass)
{
	klass->view->getCadArea()->setXlat( Vector3() );
	klass->view->redraw();
}

void ToolsetView::oneToOneClicked(GtkWidget *widget, ToolsetView *klass)
{
	klass->view->getCadArea()->setZoom( 1.0 );
	klass->view->redraw();
}


#endif
