/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLSETVIEW_H
#define __TOOLSETVIEW_H

#include <gtk/gtkwidget.h>

#include "Toolset.h"
#include "CadView.h"



class ToolsetView : public Toolset
{
private:
	CadView *view;

public:
	ToolsetView(Toolbox *tbx, CadView *vw);
	virtual ~ToolsetView();


private:
	static void topClicked(GtkWidget *widget, ToolsetView *klass);
	static void frontClicked(GtkWidget *widget, ToolsetView *klass);
	static void backClicked(GtkWidget *widget, ToolsetView *klass);
	static void bottomClicked(GtkWidget *widget, ToolsetView *klass);
	static void leftClicked(GtkWidget *widget, ToolsetView *klass);
	static void rightClicked(GtkWidget *widget, ToolsetView *klass);

	static void originClicked(GtkWidget *widget, ToolsetView *klass);
	static void oneToOneClicked(GtkWidget *widget, ToolsetView *klass);
};



#endif
