/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		16/Apr/2000
*/
#ifndef __GRIDLAYOUT_H
#define __GRIDLAYOUT_H

#include <gtk/gtktable.h>

#include "Geometry.h"



class GridLayout
{
private:
	GtkTable *tab;
	IPoint2 pos;
	GtkAttachOptions xAttachOpt, yAttachOpt;

	void resize();

public:
	GridLayout();
	GridLayout(GtkTable *t,
				  GtkAttachOptions xat = (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
				  GtkAttachOptions yat = (GtkAttachOptions)(GTK_FILL));

	GtkTable* getTableWidget();


	GtkAttachOptions getXAttachOptions() const;
	GtkAttachOptions getYAttachOptions() const;
	void setAttachOptions(
			GtkAttachOptions xat = (GtkAttachOptions)(GTK_FILL | GTK_EXPAND),
			GtkAttachOptions yat = (GtkAttachOptions)(GTK_FILL) );


	IPoint2 getPosition() const;
	void setPosition(const IPoint2& p);

	ISize2 getSize() const;
	void expand(const ISize2& s);

	void line(int lines = 1);
	void lineSpace(int lines = 1);
	void nextLine();						//leave a blank line
	void newLine();						//go to the next empty line
	void space(int nspaces = 1);
	void add(GtkWidget *w, int width = 1);
	void add( GtkWidget *w, GtkAttachOptions xat, GtkAttachOptions yat,
				 int width = 1 );
	void addAsLine(GtkWidget *w);
	void addAsLine( GtkWidget *w, GtkAttachOptions xat, GtkAttachOptions yat );
	void addAsBlock(GtkWidget *w, const ISize2& s);
	void addAsBlock( GtkWidget *w, const ISize2& s,
						  GtkAttachOptions xat, GtkAttachOptions yat );
	void remove(GtkWidget *w);
};



#endif
