/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		10/Jul/2000
*/
#ifndef __LISTMANAGER_H
#define __LISTMANAGER_H

#include <set>
#include <string>

#include <gtk/gtkwidget.h>




class ListManager
{
private:
	GtkWidget *gtkLs, *scrolledWindow;
	multiset<string> names;
	string currentSelection;

public:
	ListManager(const string& columnTitle = "Name");
	~ListManager();

	bool exists(const string& n) const;
	void add(const string& n);
	void remove(const string& n);
	void clear();
	string getSelection() const;

	GtkWidget* getWidget();

private:
	void updateList();

	static void select_row(GtkWidget *widget, gint row, gint col,
								  GdkEventButton *event, ListManager *klass);
};



#endif
