/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		03/Jul/2000
*/
#ifndef __NAMEDIALOG_H
#define __NAMEDIALOG_H

#include <string>

#include <gtk/gtkwidget.h>

#include "callback.h"




class NameDialog;




class NameDialogListener
{
public:
	virtual void okPressed(NameDialog *d, const string& name);
	virtual void cancelPressed(NameDialog *d);
};




class NameDialog
{
public:
	typedef callback<NameDialog, string, void> OkCallback;
	typedef callback<NameDialog, void*, void> CancelCallback;

private:
	GtkWidget *win, *table, *promptLabel, *entry, *ok, *cancel;
	bool okSelected;
	
	OkCallback okCall;
	CancelCallback canCall;
	NameDialogListener *listener;

public:
	NameDialog(const string& title = "Name", const string& prompt = "name:");
	NameDialog(OkCallback ocb, CancelCallback ccb,
				  const string& title = "Name", const string& prompt = "name:");
	NameDialog(NameDialogListener *l,
				  const string& title = "Name", const string& prompt = "name:");
	~NameDialog();

private:
	void constructorCommon(const string& title, const string& prompt);

	static void ok_response(GtkWidget *widget, NameDialog *klass);
	static void can_response(GtkWidget *widget, NameDialog *klass);
	static void win_destroy(GtkWidget *widget, NameDialog *klass);
};



#endif
