/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by:					Geoffrey French
	application:		gSculpt
	last revision:		03/Jul/2000
*/
#ifndef __NUMERICENTRY_H
#define __NUMERICENTRY_H

#include <gtk/gtkwidget.h>




class NumericEntry
{
private:
	GtkWidget *spinbt;
	GtkObject *adj;
	GtkSignalFunc changeResponseFunction;
	gpointer changeResponseData;
	bool blockChangeEvents;


public:
	NumericEntry(double value, double lower, double upper,
					 double stepInc, double pageInc, double climbRate,
					 int digits);
	NumericEntry(double value, double lower, double upper,
					 double stepInc, double pageInc, double climbRate,
					 int digits, GtkSignalFunc responseFunc,
					 gpointer responseData);
	~NumericEntry();


private:
	void constructorCommon(double value, double lower, double upper,
								  double stepInc, double pageInc, double climbRate,
								  int digits);

public:
	GtkWidget* getWidget();


	void wrap();
	void nowrap();

	void snap();
	void nosnap();


	void connect(GtkSignalFunc responseFunc, gpointer responseData);
	void disconnect();


	void setValue(double v);

	double getValue() const;
	int getValueAsInt() const;

private:
	static void valueChangedResponse(GtkObject *obj, NumericEntry *klass);
};


#endif
