/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef MESSAGEBOXCPP
#define MESSAGEBOXCPP

#include <gtk/gtkdialog.h>
#include <gtk/gtklabel.h>
#include <gtk/gtkbutton.h>
#include <gtk/gtksignal.h>
#include <gtk/gtkbbox.h>

#include "messageBox.h"


/*
*******************************************************************************
										messageBox
*******************************************************************************
*/

void messageBox(const string& title, const string& message)
{
	GtkWidget *dialog, *label, *ok;
	
	dialog = gtk_dialog_new();
	gtk_window_set_title( GTK_WINDOW(dialog), title.c_str() );


	label = gtk_label_new( message.c_str() );

	ok = gtk_button_new_with_label("OK");

	gtk_signal_connect_object( GTK_OBJECT(ok), "clicked",
										GTK_SIGNAL_FUNC(gtk_widget_destroy),
										GTK_OBJECT(dialog) );

	

	gtk_box_pack_start( GTK_BOX( GTK_DIALOG(dialog)->vbox ), label,
							  true, true, 10 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG(dialog)->action_area ), ok,
							  true, true, 10 );


	gtk_widget_show(label);
	gtk_widget_show(ok);
	gtk_widget_show(dialog);
}

void messageBox(const string& title, const vector<string>& messages)
{
	GtkWidget *dialog, *label, *ok;
	
	dialog = gtk_dialog_new();
	gtk_window_set_title( GTK_WINDOW(dialog), title.c_str() );


	for (int i = 0; i < (int)messages.size(); i++)
	{
		label = gtk_label_new( messages[i].c_str() );
		gtk_box_pack_start( GTK_BOX( GTK_DIALOG(dialog)->vbox ), label,
								  true, true, 10 );
		gtk_widget_show(label);
	}

	ok = gtk_button_new_with_label("OK");

	gtk_signal_connect_object( GTK_OBJECT(ok), "clicked",
										GTK_SIGNAL_FUNC(gtk_widget_destroy),
										GTK_OBJECT(dialog) );

	

	gtk_box_pack_start( GTK_BOX( GTK_DIALOG(dialog)->action_area ), ok,
							  true, true, 10 );


	gtk_widget_show(ok);
	gtk_widget_show(dialog);
}



#endif
