/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef CAEH_GRIDH
#define CAEH_GRIDH

#include "Line3.h"
#include "CGrid.h"
#include "CadArea.h"
#include "Frame.h"



class CAEH_grid : public CAEventHandler
{
private:
	CGrid g;
	bool gridChanged;
	Frame viewFrame;

	struct LevelLineList
	{
		array<ILine2> hlines;
		array<double> hvalues;
		array<ILine2> vlines;
		array<double> vvalues;
		DAColour col;
	};

	array<LevelLineList> lineList;

public:
	CAEH_grid(CadArea *c, const CGrid& gr = CGrid());
	virtual ~CAEH_grid();
	
	void setGrid(const CGrid& gr = CGrid());

	virtual void paint();

	void generateList();
};



#endif
