/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __MODELDRAW_CPP
#define __MODELDRAW_CPP

#include "ModelDraw.h"



DAColour modeldraw_vtx_unmarked;
DAColour modeldraw_vtx_marked;
DAColour modeldraw_edge;
DAColour modeldraw_background;
DAColour modeldraw_select;

void modelDrawInitialiseColours()
{
	modeldraw_vtx_unmarked = DAColour(0xffff, 0x0, 0x0);
	modeldraw_vtx_marked = DAColour(0x0, 0xffff, 0x0);
	modeldraw_edge = DAColour(0xffff, 0xffff, 0xffff);
	modeldraw_background = DAColour(0x6666, 0x6666, 0x6666);
	modeldraw_select = DAColour(0xffff, 0xaaaa, 0x0000);
}

void modelDrawUnmarkedVertex(DrawingArea *ar, const IPoint2& p)
{
	ar->setForeground( modeldraw_vtx_unmarked );
	ar->drawRectangle( IRect2(p - IVector2(1, 1), ISize2(2, 2) ) );
}

void modelDrawMarkedVertex(DrawingArea *ar, const IPoint2& p)
{
	ar->setForeground( modeldraw_vtx_marked );
	ar->drawRectangle( IRect2(p - IVector2(1, 1), ISize2(2, 2) ) );
}

void modelDrawEdge(DrawingArea *ar, const ILine2& l)
{
	ar->setForeground( modeldraw_edge );
	ar->drawLine( l );
}

void modelDrawEdgeBackground(DrawingArea *ar, const ILine2& l)
{
	ar->setForeground( modeldraw_background );
	ar->drawLine( l );
}

void modelDrawSelectBox(DrawingArea *ar, const IRect2& r)
{
	ar->setForeground( modeldraw_select );
	ar->drawRectangle( r );
}

void modelDrawSelectCircle(DrawingArea *ar, const IPoint2& centre, int radius)
{
	ar->setForeground( modeldraw_select );
	ar->drawArc( centre - IVector2(radius, radius),
					 ISize2(radius << 1, radius << 1), 0, 23040 );
}



#endif
 
