/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*	by :					Geoffrey French
	application :		gSculpt
	last revision :	22/Jun/2000
	title :				Model Drawing
	puspose :			functions to draw models (vertices, edges)
*/
#ifndef __MODELDRAW_H
#define __MODELDRAW_H

#include "DrawingArea.h"
#include "Geometry.h"



void modelDrawInitialiseColours();
void modelDrawUnmarkedVertex(DrawingArea *ar, const IPoint2& p);
void modelDrawMarkedVertex(DrawingArea *ar, const IPoint2& p);
void modelDrawEdge(DrawingArea *ar, const ILine2& l);
void modelDrawEdgeBackground(DrawingArea *ar, const ILine2& l);
void modelDrawSelectBox(DrawingArea *ar, const IRect2& r);
void modelDrawSelectCircle(DrawingArea *ar, const IPoint2& centre, int radius);



#endif

