/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
/*
	by :					Geoffrey French
	application :		gSculpt
	last revision :	09/Jul/2000
	title :				Pointer Status class
	puspose :			Store infromation on pointer position, and mouse
							button status
*/
#ifndef __POINTERSTATUS_H
#define __POINTERSTATUS_H

#include "array.h"

#include "Geometry.h"



class PointerStatus
{
private:
	IPoint2 pos;
	bool in;
	array<bool> buttons;
	int modifierKeyStates;

public:
	//constructors
	PointerStatus();
	PointerStatus(const IPoint2& position, int nb, bool inside);
	PointerStatus(const IPoint2& position, const array<bool>& bt, bool inside);

	//set position, button flags, and in flag
	void setPosition(const IPoint2& position);
	void setButton(int bt);
	void clearButton(int bt);
	void setInside();
	void clearInside();
	void setModifierKeyStates(int s);

	//get position and flags
	IPoint2 getPosition() const;
	bool getButton(int bt) const;
	bool isInside() const;
	int getModifierKeyStates() const;
	bool isShift() const;
	bool isControl() const;
	bool isAlt() const;
};



#endif
