/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __ABSTRANSFORMATION_CPP
#define __ABSTRANSFORMATION_CPP

#include "AbsTransformation.h"



AbsTransformation::AbsTransformation() : Transformation()
{
}


AbsTransformation::AbsTransformation(const Transformation *x)
												 : Transformation(x)
{
}



Transformation* AbsTransformation::clone() const
{
	return new AbsTransformation(this);
}


Point3 AbsTransformation::xfPoint(const Point3& p) const
{
	return Point3( p.x, p.y, abs_polar(p.x, p.y) );
}

Vector3 AbsTransformation::xfVector(const Vector3& v, const Point3& at) const
{
	//no need to subtract the result of transforming the origin, because
	//the origin remains unchanged
	return Vector3( v.x, v.y, 0.0 );
}



#endif

