/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __ABSTRANSFORMATION_H
#define __ABSTRANSFORMATION_H


#include "polar.h"
#include "Vector3.h"
#include "Point3.h"
#include "Transformation.h"
#include "Matrix4.h"



class AbsTransformation : public Transformation
{
public:
	AbsTransformation();
protected:
	AbsTransformation(const Transformation *x);

public:
	virtual Transformation* clone() const;

protected:
	virtual Point3 xfPoint(const Point3& p) const;
	virtual Vector3 xfVector(const Vector3& v, const Point3& at) const;
};



#endif
