/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __ATTRACTORTRANSFORMATION_H
#define __ATTRACTORTRANSFORMATION_H

#include "Vector3.h"
#include "Point3.h"
#include "Transformation.h"



class AttractorTransformation : public Transformation
{
protected:
	double strength, sharpness;
	Point3 centre, orig;
	int iterations;
	bool in3D;
	
public:
	AttractorTransformation();
	AttractorTransformation(double str, double sh, const Point3& c, int it,
									bool td);
protected:
	AttractorTransformation(double str, double sh, const Point3& c, int it,
									bool td, const Point3& o,
									const Transformation *x);

public:
	virtual Transformation* clone() const;

protected:
	virtual Point3 xfPoint(const Point3& p) const;
	virtual Vector3 xfVector(const Vector3& v, const Point3& at) const;
	virtual Vector3 movement(double force, double dist,
									 const Vector3& centreToPoint) const;
};



#endif
