/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __BENDTRANSFORMATION_H
#define __BENDTRANSFORMATION_H

#include "Vector3.h"
#include "Point3.h"
#include "Transformation.h"



class BendTransformation : public Transformation
{
protected:
	double grad;
	
public:
	BendTransformation();
	BendTransformation(double dAdX);
protected:
	BendTransformation(double dAdX, const Transformation *x);


public:
	virtual Transformation* clone() const;

protected:
	virtual Point3 xfPoint(const Point3& p) const;
	virtual Vector3 xfVector(const Vector3& v, const Point3& at) const;
};



#endif
