/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __FLUIDTRANSFORMATION_CPP
#define __FLUIDTRANSFORMATION_CPP

#include "FluidTransformation.h"


FluidTransformation::FluidTransformation() : AttractorTransformation()
{
	direction = Vector3(1.0, 0.0, 0.0);
}

FluidTransformation::FluidTransformation(double str, double sh, const Vector3& dir,
													  const Point3& c, int it, bool td)
													  : AttractorTransformation(str, sh, c,
													  									 it, td)
{
	direction = dir;
	orig = xfPoint(Point3());
}
													  		
FluidTransformation::FluidTransformation(double str, double sh, const Vector3& dir,
													  const Point3& c, int it, bool td,
													  const Point3& o,
													  const Transformation *x)
													  : AttractorTransformation(str, sh, c,
													  									 it, td, o, x)
{
	direction = dir;
	orig = xfPoint(Point3());
}


Transformation* FluidTransformation::clone() const
{
	return new FluidTransformation( strength, sharpness, direction, centre,
											  iterations, in3D, orig, this );
}


Vector3 FluidTransformation::movement(double force, double dist,
												  const Vector3& centreToPoint) const
{
	return direction * force;
}

													  		


#endif
