/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __MAGNETTRANSFORMATION_CPP
#define __MAGNETTRANSFORMATION_CPP

#include "MagnetTransformation.h"


MagnetTransformation::MagnetTransformation() : AttractorTransformation()
{
}

MagnetTransformation::MagnetTransformation(double str, double sh,
														 const Point3& c, int it, bool td)
													    : AttractorTransformation(str, sh, c,
													  										it, td)
{
	orig = xfPoint(Point3());
}
													  		
MagnetTransformation::MagnetTransformation(double str, double sh,
														 const Point3& c, int it, bool td,
														 const Point3& o,
														 const Transformation *x)
														 : AttractorTransformation(str, sh, c,
													  										it, td, o, x)
{
	orig = xfPoint(Point3());
}


Transformation* MagnetTransformation::clone() const
{
	return new MagnetTransformation( strength, sharpness, centre,
											   iterations, in3D, orig, this );
}


Vector3 MagnetTransformation::movement(double force, double dist,
													const Vector3& centreToPoint) const
{
	double fraction = force / dist;

	//make sure the point doesn't move through the centre
	if (fraction > 1.0)
	{
		fraction = 1.0;
	}

	return -centreToPoint * fraction;
}
													  		


#endif
