/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __MAGNETTRANSFORMATION_H
#define __MAGNETTRANSFORMATION_H

#include "Vector3.h"
#include "Point3.h"
#include "Transformation.h"
#include "AttractorTransformation.h"



class MagnetTransformation : public AttractorTransformation
{
public:
	MagnetTransformation();
	MagnetTransformation(double str, double sh, const Point3& c, int it, bool td);

private:
	MagnetTransformation(double str, double sh, const Point3& c, int it, bool td,
								const Point3& o, const Transformation *x);

public:
	virtual Transformation* clone() const;

protected:
	virtual Vector3 movement(double force, double dist,
									 const Vector3& centreToPoint) const;
};



#endif
