/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __MATRIXTRANSFORMATION_CPP
#define __MATRIXTRANSFORMATION_CPP

#include "MatrixTransformation.h"



/*
*******************************************************************************
										MatrixTransformation
*******************************************************************************
*/

MatrixTransformation::MatrixTransformation() : Transformation()
{
	matrix = Matrix4();
}

MatrixTransformation::MatrixTransformation(const Matrix4& m) : Transformation()
{
	matrix = m;
}

MatrixTransformation::MatrixTransformation(const Matrix4& m,
														 const Transformation *x)
														 : Transformation(x)
{
	matrix = m;
}



Transformation* MatrixTransformation::clone() const
{
	return new MatrixTransformation( matrix, this );
}


Point3 MatrixTransformation::xfPoint(const Point3& p) const
{
	return p * matrix;
}

Vector3 MatrixTransformation::xfVector(const Vector3& v, const Point3& at) const
{
	return v * matrix;
}


#endif
