/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __MATRIXTRANSFORMATION_H
#define __MATRIXTRANSFORMATION_H

#include "Vector3.h"
#include "Point3.h"
#include "Matrix4.h"
#include "Transformation.h"


/*
*******************************************************************************
										MatrixTransformation
*******************************************************************************
*/

class MatrixTransformation : public Transformation
{
protected:
	Matrix4 matrix;				//the matrix

public:
	MatrixTransformation();
	MatrixTransformation(const Matrix4& m);
protected:
	MatrixTransformation(const Matrix4& m, const Transformation *x);

public:
	virtual Transformation* clone() const;

protected:
	virtual Point3 xfPoint(const Point3& p) const;
	virtual Vector3 xfVector(const Vector3& v, const Point3& at) const;
};


#endif
