/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __SNAPTRANSFORMATION_CPP
#define __SNAPTRANSFORMATION_CPP

#include "SnapTransformation.h"



SnapTransformation::SnapTransformation() : Transformation()
{
}

SnapTransformation::SnapTransformation(const Vector3& snapGranularity)
													: Transformation()
{
	snapper = VectorSnap(snapGranularity);
}


SnapTransformation::SnapTransformation(const Transformation *x)
													: Transformation(x)
{
}



Transformation* SnapTransformation::clone() const
{
	return new SnapTransformation(this);
}


Point3 SnapTransformation::xfPoint(const Point3& p) const
{
	return snapper.snap(p);
}

Vector3 SnapTransformation::xfVector(const Vector3& v, const Point3& at) const
{
	return v;
}



#endif

