/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __SNAPTRANSFORMATION_H
#define __SNAPTRANSFORMATION_H


#include "Vector3.h"
#include "Point3.h"
#include "Transformation.h"
#include "VectorSnap.h"



class SnapTransformation : public Transformation
{
private:
	VectorSnap snapper;
	
public:
	SnapTransformation();
	SnapTransformation(const Vector3& snapGranularity);
protected:
	SnapTransformation(const Transformation *x);

public:
	virtual Transformation* clone() const;

protected:
	virtual Point3 xfPoint(const Point3& p) const;
	virtual Vector3 xfVector(const Vector3& v, const Point3& at) const;
};



#endif
