/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TAPERTRANSFORMATION_H
#define __TAPERTRANSFORMATION_H

#include "Vector3.h"
#include "Point3.h"
#include "Transformation.h"
#include "Matrix4.h"



class TaperTransformation : public Transformation
{
protected:
	double zeroU, dUdD, zeroV, dVdD;
	
public:
	TaperTransformation();
	TaperTransformation(double d0, double u0, double v0,
							  double d1, double u1, double v1);
protected:
	TaperTransformation(double zu, double gu, double zv, double gv,
							  const Transformation *x);

public:
	virtual Transformation* clone() const;

protected:
	virtual Point3 xfPoint(const Point3& p) const;
	virtual Vector3 xfVector(const Vector3& v, const Point3& at) const;
};



#endif
