/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TRANSFORMATION_H
#define __TRANSFORMATION_H

#include "Vector3.h"
#include "Point3.h"


/*
*******************************************************************************
										Transformation
*******************************************************************************
*/

class Transformation
{
private:
	Transformation *child;
	
public:
	Transformation();
	Transformation(const Transformation *c);
	virtual ~Transformation();

	//methods to transform a point or a vector
	Point3 transformPoint(const Point3& p) const;
	Vector3 transformVector(const Vector3& v, const Point3& at) const;

	void setChild(const Transformation *x);


	virtual Transformation* clone() const;

protected:
	virtual Point3 xfPoint(const Point3& p) const;
	virtual Vector3 xfVector(const Vector3& v, const Point3& at) const;
};


#endif
