/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TWISTTRANSFORMATION_H
#define __TWISTTRANSFORMATION_H

#include "polar.h"
#include "Vector3.h"
#include "Point3.h"
#include "Transformation.h"
#include "Matrix4.h"



class TwistTransformation : public Transformation
{
public:
	typedef enum {
		LINEAR,
		RADIAL
	} TwistType;
	
protected:
	Vector3 axis;
	double zeroR, dRdD;
	TwistType type;
	
public:
	TwistTransformation();
	TwistTransformation(double d0, double r0, double d1, double r1,
							  TwistType t);
protected:
	TwistTransformation(double zr, double g, TwistType t,
							  const Transformation *x);


public:
	virtual Transformation* clone() const;

protected:
	virtual Point3 xfPoint(const Point3& p) const;
	virtual Vector3 xfVector(const Vector3& v, const Point3& at) const;
};



#endif
