/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __PROCXFORM_CPP
#define __PROCXFORM_CPP

#include "ProcXform.h"





void* __create_ProcXform()
{
	return (void*)( new ProcXform() );
}

ObjectType type_ProcXform("ProcXform", "JournalProcess", __create_ProcXform);






ProcXform::ProcXform() : JournalProcess()
{
}

ProcXform::~ProcXform()
{
}



void ProcXform::read(FILE *f)
{
	JournalProcess::read(f);
}

void ProcXform::write(FILE *f)
{
	JournalProcess::write(f);
}





string ProcXform::getDescription() const
{
	return "Transformation";
}

const ObjectType* ProcXform::getType() const
{
	return &type_ProcXform;
}

const ObjectType* ProcXform::getTypeStatic()
{
	return &type_ProcXform;
}



const ObjectType* ProcXform::getInputType() const
{
	return JournalModel::getTypeStatic();
}



JournalProcess* ProcXform::clone() const
{
	return new ProcXform();
}



const ObjectType* ProcXform::_getOutputType(const ObjectType* inputType) const
{
	return inputType;
}

JournalObject* ProcXform::_process(JournalObject *o,
											  JournalTaskProgress *progress)
{
	JournalModel *hmodel = (JournalModel*)o;
	transformModel( hmodel );
	return (JournalObject*)hmodel;
}

void ProcXform::_processInto(JournalObject *o, JournalObject *dst,
									  JournalTaskProgress *progress)
{
	dst->copyFrom(o);
	JournalModel *hmodel = (JournalModel*)dst;
	transformModel( hmodel );
}

void ProcXform::transformModel(JournalModel *model) const
{
}




#endif

