/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __PROCXFORM_H
#define __PROCXFORM_H

#include "TypeManager.h"
#include "JournalModel.h"
#include "JournalProcess.h"
#include "JournalTaskProgress.h"



class ProcXform : public JournalProcess
{
public:
	ProcXform();
	virtual ~ProcXform();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual const ObjectType* getInputType() const;

	virtual JournalProcess* clone() const;


protected:
	virtual const ObjectType* _getOutputType(const ObjectType* inputType) const;
	virtual JournalObject* _process(JournalObject *o,
											  JournalTaskProgress *progress);
	virtual void _processInto(JournalObject *o, JournalObject *dst,
									  JournalTaskProgress *progress);

	virtual void transformModel(JournalModel *model) const;
};



#endif
