/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLGROUPXFORM_H
#define __TOOLGROUPXFORM_H

#include <gtk/gtkwidget.h>

#include "MToolGroup.h"

#include "ToolXfTranslate.h"
#include "ToolXfMoveTo.h"
#include "ToolXfRotate.h"
#include "ToolXfSnap.h"
#include "ToolXfScale.h"
#include "ToolXfScale3D.h"
#include "ToolXfShear.h"
#include "ToolXfTwist.h"
#include "ToolXfTaper.h"
#include "ToolXfBend.h"
#include "ToolXfBend3D.h"
#include "ToolXfMagnet.h"

#include "JournalEditor.h"

#include "CadView.h"
#include "Toolbox.h"
#include "ObjPainterManager.h"



class ToolGroupXform : public MToolGroup
{
private:
	JournalEditor *journalEditor;

	GtkWidget *titleLabel;
	GtkWidget *xlatButton, *movetoButton, *rotButton,
				 *snapButton, *scaleButton, *scale3dButton,
				 *shearButton, *twistButton, *taperButton,
				 *bendButton, *bend3DButton, *magnetButton;

	ToolXfTranslate *toolXlat;
	ToolXfMoveTo *toolMoveto;
	ToolXfRotate *toolRot;
	ToolXfSnap *toolSnap;
	ToolXfScale *toolScale;
	ToolXfScale3D *toolScale3d;
	ToolXfShear *toolShear;
	ToolXfTwist *toolTwist;
	ToolXfTaper *toolTaper;
	ToolXfBend *toolBend;
	ToolXfBend3D *toolBend3D;
	ToolXfMagnet *toolMagnet;
	

public:
	ToolGroupXform(ProcessToolManager *toolManager,
						JournalEditor *journEditor, CadView *view,
						ObjPainterManager *painterManager);
	virtual ~ToolGroupXform();


	virtual void addToLayout(GridLayout *layout);


private:
	static void xlatClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void movetoClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void rotClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void snapClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void scaleClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void scale3dClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void shearClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void twistClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void taperClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void bendClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void bend3DClicked(GtkWidget *widget, ToolGroupXform *klass);
	static void magnetClicked(GtkWidget *widget, ToolGroupXform *klass);
};



#endif
