/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLXFSCALE3D_H
#define __TOOLXFSCALE3D_H


#include <string>


#include "Vector3.h"
#include "Axes3.h"
#include "ProcXform.h"
#include "ValueSnap.h"
#include "ToolXformCentre.h"
#include "NumericEntry.h"



class ProcXfScale3D : public ProcXformCentre
{
private:
	double scaleFactor;
	
public:
	ProcXfScale3D();
	ProcXfScale3D(Centre cen, double r);
	virtual ~ProcXfScale3D();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual JournalProcess* clone() const;


	void setScaleFactor(double s);
	double getScaleFactor() const;

protected:
	virtual void transformModel(JournalModel *model, const Point3& centre) const;
};



class ToolXfScale3D : public ToolXformCentre
{
private:
	GtkWidget *snapLabel;
	NumericEntry *snapEntry;

	GtkWidget *scaleLabel;
	NumericEntry *scaleEntry;

	GtkWidget *doneButton;


	ValueSnap snapper;


	double initialScaleFactor;

public:
	ToolXfScale3D(CadView *v, ObjPainterManager *pman);
	virtual ~ToolXfScale3D();


	virtual const ObjectType* getProcessType() const;


protected:
	virtual void initialise();

	virtual void start();
	virtual void finish(bool terminated);
	virtual void function();
	
private:
	static void scaleChanged(NumericEntry *widget, ToolXfScale3D *klass);
	static void doneClicked(GtkWidget *widget, ToolXfScale3D *klass);
};



#endif
