/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLXFORMAXIS_H
#define __TOOLXFORMAXIS_H


#include <string>


#include "Vector3.h"
#include "Axes3.h"
#include "ProcXform.h"
#include "ToolXformClickAndDrag.h"
#include "CadToolAxisChooser.h"



class ProcXformAxis : public ProcXform
{
protected:
	Axis axis;
	
public:
	ProcXformAxis();
	ProcXformAxis(Axis a);
	virtual ~ProcXformAxis();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual JournalProcess* clone() const;


	void setAxis(Axis a);
	Axis getAxis() const;

protected:
	virtual void transformModel(JournalModel *m) const;
	virtual void transformModel(JournalModel *model, const Point3& centre,
										 const Matrix4& axesMatrix,
										 const Matrix4& axesMatrixInverse,
										 const BBox& boundingBoxInTransformationSpace) const;
};



class ToolXformAxis : public ToolXformClickAndDrag
{
protected:
	CadToolAxisChooser *axisChooser;


public:
	ToolXformAxis(CadView *v, ObjPainterManager *pman,
					  const string& funcName, const string& optTitle,
					  int tableWidth = 1);
	virtual ~ToolXformAxis();


	virtual const ObjectType* getProcessType() const;

protected:
	virtual void initialise();


private:
	static void axisChanged(GtkWidget *widget, ToolXformAxis *klass);
};



#endif
