/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLXFORMCENTRE_H
#define __TOOLXFORMCENTRE_H


#include <string>


#include "Vector3.h"
#include "Axes3.h"
#include "ProcXform.h"
#include "ToolXformClickAndDrag.h"
#include "CadToolCentreChooser.h"



class ProcXformCentre : public ProcXform
{
protected:
	Centre whichCentre;
	
public:
	ProcXformCentre();
	ProcXformCentre(Centre cen);
	virtual ~ProcXformCentre();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual JournalProcess* clone() const;


	void setCentre(Centre cen);
	Centre getCentre() const;

protected:
	virtual void transformModel(JournalModel *m) const;
	virtual void transformModel(JournalModel *model, const Point3& centre) const;
};



class ToolXformCentre : public ToolXformClickAndDrag
{
protected:
	CadToolCentreChooser *centreChooser;


public:
	ToolXformCentre(CadView *v, ObjPainterManager *pman,
						 const string& funcName, const string& optTitle,
						 int tableWidth = 1);
	virtual ~ToolXformCentre();


	virtual const ObjectType* getProcessType() const;


protected:
	virtual void initialise();


private:
	static void centreChanged(GtkWidget *klass, ToolXformCentre *klass);
};



#endif
