/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __TOOLXFORMCENTREAXIS_H
#define __TOOLXFORMCENTREAXIS_H


#include <string>


#include "Vector3.h"
#include "Axes3.h"
#include "ToolXformCentre.h"
#include "CadToolAxisChooser.h"



class ProcXformCentreAxis : public ProcXformCentre
{
protected:
	Axis axis;
	
public:
	ProcXformCentreAxis();
	ProcXformCentreAxis(Centre cen, Axis a);
	virtual ~ProcXformCentreAxis();


	virtual void read(FILE *f);
	virtual void write(FILE *f);



	virtual string getDescription() const;
	virtual const ObjectType* getType() const;
	static const ObjectType* getTypeStatic();

	virtual JournalProcess* clone() const;


	void setAxis(Axis a);
	Axis getAxis() const;

protected:
	virtual void transformModel(JournalModel *m) const;
	virtual void transformModel(JournalModel *model, const Point3& centre,
										 const Matrix4& axesMatrix,
										 const Matrix4& axesMatrixInverse,
										 const BBox& boundingBoxInTransformationSpace) const;
};



class ToolXformCentreAxis : public ToolXformCentre
{
protected:
	CadToolAxisChooser *axisChooser;


public:
	ToolXformCentreAxis(CadView *v, ObjPainterManager *pman,
						  const string& funcName, const string& optTitle,
						  int tableWidth = 1);
	virtual ~ToolXformCentreAxis();


	virtual const ObjectType* getProcessType() const;


protected:
	virtual void initialise();

private:
	static void axisChanged(GtkWidget *widget, ToolXformCentreAxis *klass);
};



#endif
