/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#ifndef __GSCULPTCONFIG_CPP
#define __GSCULPTCONFIG_CPP

#include "gSculptConfig.h"



const char __config_versionAsString[] = "0.3";
const int __config_versionAsInts[] = {0, 3, 0, 0};



bool gSculptConfigIsMultiThreaded()
{

#ifdef GSCULPT_CONFIG_MULTITHREADED
	return true;
#else
	return false;
#endif

}




const char* getVersionAsString()
{
	return __config_versionAsString;
}

const int* getVersionAsInts()
{
	return __config_versionAsInts;
}


bool checkVersionCompatibility(const int *fileVersion, const int *myVersion)
{
	for (int i = 0; i < 4; i++)
	{
		if ( fileVersion[0] > myVersion[0] )
		{
			return false;			//file version is greater
		}
		else if ( fileVersion[0] < myVersion[0] )
		{
			return true;			//my version is greater
		}
	}

	return true;			//versions are equal
}


bool checkFileHeader(const char *fileHeader)
{
	return fileHeader[0] == 'g' &&
			 fileHeader[1] == 'S' &&
			 fileHeader[2] == 'c' &&
			 fileHeader[3] == 0x00;
	
}



#endif

