/************************
 This code is released under the terms of the GNU GPL, v2 (or any later version).
 The GNU GPL can be found in the file 'COPYING'.  Copyright Geoffrey French 1999-2001.
 ************************/
#include <stdio.h>

#include <gtk/gtk.h>

#include "ModelDraw.h"

#include "JournalThreads.h"

#include "MultiThreading.h"

#include "GSculptApp.h"



void quit(CObjectEditor *ed, gpointer data)
{
	gtk_main_quit();
}


int main(int argc, char *argv[])
{
	initialiseTypeManager();

	gtk_init(&argc, &argv);

	initThreads();

	initJournalThreads();

	modelDrawInitialiseColours();


	GSculptApp app( GTK_SIGNAL_FUNC(quit), NULL );


	gtk_main();

	shutdownJournalThreads();


	shutdownTypeManager();



	return 0;
}


